Package: multiHiCcompare
Title: Normalize and detect differences between Hi-C datasets when
        replicates of each experimental condition are available
Version: 1.30.0
Authors@R: c(
    person(given = "Mikhail",
           family = "Dozmorov",
           role = c("aut", "cre"),
           email = "mikhail.dozmorov@gmail.com",
           comment = c(ORCID = "0000-0002-0086-8358")),
    person(given = "John",
           family = "Stansfield",
           role = c("aut"),
           email = "stansfieldjc@vcu.edu"))
Description: multiHiCcompare provides functions for joint normalization 
    and difference detection in multiple Hi-C datasets. This extension of
    the original HiCcompare package now allows for Hi-C experiments with 
    more than 2 groups and multiple samples per group. multiHiCcompare 
    operates on processed Hi-C data in the form of sparse upper triangular 
    matrices. It accepts four column (chromosome, region1, region2, IF)
    tab-separated text files storing chromatin interaction matrices. 
    multiHiCcompare provides cyclic loess and fast loess (fastlo) methods
    adapted to jointly normalizing Hi-C data. Additionally, it provides 
    a general linear model (GLM) framework adapting the edgeR package to detect
    differences in Hi-C data in a distance dependent manner. 
Depends: R (>= 4.0.0)
Imports: data.table, dplyr, HiCcompare, edgeR, BiocParallel, qqman,
        pheatmap, methods, GenomicRanges, graphics, stats, utils,
        pbapply, GenomeInfoDbData, GenomeInfoDb, aggregation
biocViews: Software, HiC, Sequencing, Normalization
License: MIT + file LICENSE
Encoding: UTF-8
LazyData: true
Suggests: knitr, rmarkdown, testthat, BiocStyle
RoxygenNote: 7.1.1
VignetteBuilder: knitr
BugReports: https://github.com/dozmorovlab/multiHiCcompare/issues
URL: https://github.com/dozmorovlab/multiHiCcompare
git_url: https://git.bioconductor.org/packages/multiHiCcompare
git_branch: RELEASE_3_23
git_last_commit: 0adf2ca
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:30:33 UTC; biocbuild
Author: Mikhail Dozmorov [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-0086-8358>),
  John Stansfield [aut]
Maintainer: Mikhail Dozmorov <mikhail.dozmorov@gmail.com>

# [multiHiCcompare](https://dozmorovlab.github.io/multiHiCcompare/)

<!-- badges: start -->
[![BioC status](http://www.bioconductor.org/shields/build/release/bioc/multiHiCcompare.svg)](https://bioconductor.org/checkResults/release/bioc-LATEST/multiHiCcompare)
[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-brightgreen.svg)](https://www.tidyverse.org/lifecycle/#stable)
<!-- badges: end -->

## Overview

`multiHiCcompare` is an extension of the original [HiCcompare R package](http://bioconductor.org/packages/HiCcompare/). `multiHiCcompare` provides functions for the joint normalization and comparison of complex Hi-C experiments. `multiHiCcompare` operates on processed Hi-C data in the form of sparse upper triangular matrices.

`multiHiCcompare` accepts four-column text files storing chromatin interaction matrices in a sparse matrix format. There are many sources of public Hi-C data such as the [Aiden Lab](http://aidenlab.org/data.html) (`.hic` files) and the [Mirnylab FTP site](http://cooler.readthedocs.io/en/latest/index.html) (`.cool` files). `multiHiCcompare` performs differential chromatin interaction analysis between two biological conditions, one or multiple Hi-C matrices per condition.  

`multiHiCcompare` implements a cyclic loess joint normalization algorithm to remove bias between multiple Hi-C datasets and prepare them for comparison. `multiHiCcompare` also provides a general linear model-based difference detection method, implemented in the `edgeR` R package. 

The main functions of `multiHiCcompare` are:

- `cyclic_loess()` and `fastlo()` for performing joint normalization.
- `hic_exactTest()` and `hic_glm()` for performing comparisons between experimental conditions.

Some example Hi-C data are included in the package. Refer to the `multiHiCcompare` vignette for full usage instructions, `vignette("multiHiCcompare")`

## Installation

First, make sure you have all dependencies installed in R.

``` r
install.packages(c('dplyr', 'data.table', 'devtools', 'qqman', 'metap', 'pheatmap', 'pbapply'))

if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install(c("BiocParallel", "HiCcompare", "edgeR", "GenomicRanges", "GenomeInfoDbData"))
```

To install `multiHiCcompare` from Bioconductor, use the following commands.

``` r
# It is recommended to use the GitHub release until the next Bioconductor update
# BiocManager::install("multiHiCcompare")
# library(multiHiCcompare)
```

Or to install the latest version of `multiHiCcompare` directly from the GitHub.

``` r
library(devtools)
# Stable release
install_github('dozmorovlab/multiHiCcompare', build_vignettes = TRUE)
# Developmental version
# install_github('jstansfield0/multiHiCcompare', build_vignettes = TRUE)
library(multiHiCcompare)
```

## Usage

To use `multiHiCcompare`, you will first need to obtain some Hi-C data. Data is available from the sources listed in the overview, along with many others. You will need to extract the data and read it into R as either a 3 column sparse upper triangular matrix and then combine it with an additional column for the chromosome. Hi-C data ready to be used in `multiHiCcompare` should look like the following:

``` r
  chr  region1  region2 IF
1  22 16000000 16000000 11
2  22 16100000 16100000  1
3  22 16200000 16200000  3
4  22 16300000 16300000 15
5  22 16400000 16400000  3
6  22 16400000 16500000  1
...
```

The four columns correspond to the chromosome, the start location of the first interacting region (in base pairs), the start location of the second interacting region, and the interaction frequency (IF) of the interaction. 

Below is an example analysis of a Hi-C experiment.

``` r
# load data
library(multiHiCcompare)
data("r1", "r2", "r3", "r4")

# make hicexp object
hicexp <- make_hicexp(r1, r2, r3, r4, groups = c(1, 1, 2, 2))

# jointly normalize data
hicexp <- cyclic_loess(hicexp)

# compare groups
hicexp <- hic_exactTest(hicexp)

# view manhattan plot of results
manhattan_hicexp(hicexp)
```

## Citation

Stansfield, John C, Kellen G Cresswell, and Mikhail G Dozmorov. [MultiHiCcompare: Joint Normalization and Comparative Analysis of Complex Hi-C Experiments](https://doi.org/10.1093/bioinformatics/btz048). _Bioinformatics_, January 22, 2019. 

## Learn more

Stansfield, John C., Duc Tran, Tin Nguyen, and Mikhail G. Dozmorov. [R Tutorial: Detection of Differentially Interacting Chromatin Regions From Multiple Hi-C Datasets](https://doi.org/10.1002/cpbi.76). Current Protocols in Bioinformatics, May 2019

[HiCcompareWorkshop](https://github.com/mdozmorov/HiCcompareWorkshop) - "Detection of Differentially Interacting Chromatin Regions From Multiple Hi-C Datasets" workshop presented on Bioconductor 2020 conference


## Contributions & Support

[issue](https://github.com/dozmorovlab/HiCcompare/issues) for any of these or contact the author directly: [@jstansfield0](https://github.com/jstansfield0) (stansfieldjc@vcu.edu)

## Contributors

Authors: [@jstansfield0](https://github.com/jstansfield0) (stansfieldjc@vcu.edu) & [@mdozmorov](https://github.com/mdozmorov) (mikhail.dozmorov@vcuhealth.org)

#' Perform exact test based difference detection on a Hi-C experiment
#' 
#' @param hicexp A hicexp object.
#' @param parallel Logical, should parallel processing be used?
#' @param p.method Charact string to be input into p.adjust()
#'    as the method for multiple testing correction. Defaults to "fdr".
#' @param max.pool The proportion of unit distances after
#'     which all further distances will be pooled. Distances
#'     before this value will be progressively pooled and
#'     any distances after this value will be combined
#'     into a single pool. Defaults to 0.7. Warning: do
#'     not adjust this value from the default unless you
#'     are getting errors related to the lfproc function
#'     or due to sparsity in fastlo normalization. If these
#'     errors occur it is due to either sparsity or low 
#'     variance and max.pool will need to be lowered; 
#'     typically to 0.5 or 0.6. 
#'     
#' @details This function performs the edgeR exact test on a per distance
#'     basis for Hi-C data. It tests for differences between two groups
#'     when the groups are the only variable of interest. This is
#'     an application of the negative binomial exact test proposed
#'     by Robinson and Smyth (2008) for a difference in mean between
#'     the groups. These exact tests are applied to the Hi-C data
#'     on a distance group basis using "progressive pooling" of 
#'     distances. 
#' @return A hicexp object with the comparison slot filled.
#'
#' @export
#' @import edgeR
#' @examples 
#' \dontrun{
#' data("hicexp_diff")
#' hicexp_diff <- hic_exactTest(hicexp_diff)}
#' 

hic_exactTest <- function(hicexp, parallel = FALSE, p.method = "fdr", max.pool = 0.7) {
  # check to make sure hicexp is normalized
  if (!normalized(hicexp)) {
    warning("You should normalize the data before entering it into hic_glm")
  }
  # check to make sure there are only 2 groups
  if ( length(unique(meta(hicexp)$group)) != 2) {
    stop("If you are making a comparison where the number of groups is not 2 
         or you have covariates use hic_glm() instead.")
  }
  # First need to split up hic_table by chr and then by distance
  # split up data by chr
  table_list <- split(hic_table(hicexp), hic_table(hicexp)$chr)
  # for each chr create list of distance matrices
  table_list <- lapply(table_list, .get_dist_tables, max.pool = max.pool)
  # combine list of lists into single list of tables
  table_list <- do.call(c, table_list)
  # input each of the chr-distance tables into a DGElist object for edgeR
  dge_list <- lapply(table_list, .hictable2DGEList, covariates = meta(hicexp))
  # estimate dispersion for data
  # check number of samples per group
  if ( length(meta(hicexp)$group) == 2) { # IF no replicates use edgeR's recommended method to estimate dispersion
    dge_list <- smartApply(parallel, dge_list, edgeR::estimateGLMCommonDisp,
                                                          method="deviance", robust=TRUE, 
                                                          subset=NULL)
  } else { # If replicates for condition then use standard way for estimating dispersion
    dge_list <- smartApply(parallel, dge_list, edgeR::estimateDisp, 
                           design=model.matrix(~meta(hicexp)$group))

  }
  
  # perform exact test when the only factor is group
  et <- lapply(dge_list, edgeR::exactTest)
  
  # reformat results back into hicexp object
  comparison <- mapply(.et_reformat, et, table_list, SIMPLIFY = FALSE, 
                       MoreArgs = list(p.method = p.method))
  comparison <- data.table::rbindlist(comparison)
  # sort comparison table
  comparison <- comparison[order(chr, region1, region2),]
  slot(hicexp, "comparison") <- data.table::as.data.table(comparison)
  
  # return results
  return(hicexp)
}




#' Function to perform GLM differential analysis on Hi-C experiment
#' 
#' @param hicexp A hicexp object,
#' @param design A design matrix for the GLM.
#' @param contrast Numeric vector or matrix specifying one or more 
#'     contrasts of the linear model coefficients to be tested 
#'     equal to zero.
#' @param coef integer or character index vector indicating which 
#'     coefficients of the linear model are to be tested equal to zero. 
#' @param method The test method to be performed. Should be one of
#'    "QLFTest", "LRTest", or "Treat".
#' @param M The log2 fold change value for a TREAT analysis.
#' @param p.method p-value adjustment method to be used. Defaults
#'     to "fdr". See ?p.adjust for other adjustment options.
#' @param parallel Logical, Should parallel processing be used?
#' @param max.pool The proportion of unit distances after
#'     which all further distances will be pooled. Distances
#'     before this value will be progressively pooled and
#'     any distances after this value will be combined
#'     into a single pool. Defaults to 0.7. Warning: do
#'     not adjust this value from the default unless you
#'     are getting errors related to the lfproc function
#'     or due to sparsity in fastlo normalization. If these
#'     errors occur it is due to either sparsity or low 
#'     variance and max.pool will need to be lowered; 
#'     typically to 0.5 or 0.6. 
#'     
#' @details This function performs the specified edgeR GLM based test
#'     on a per distance basis on the Hi-C data. Distances groups
#'     are pooled using "progressive pooling". There are 3 options
#'     for the type of GLM based test to be used which is specified
#'     with the method option. \cr
#'     \code{QLFTest} will use edgeR's glmQLFit and glmQLFTest functions which
#'     makes use of quasi-likelihood methods described in Lund
#'     et al (2012). \cr
#'     \code{LRTest} uses edgeR's glmFit and glmLRT functions which uses
#'     a interaction-wise negative binomial general linear model.
#'     This method uses a likelihood ratio test for the coefficients
#'     specified in the model. \cr
#'     \code{Treat} uses edgeR's glmTreat function which performs a test
#'     for differential expression with a minimum required fold-change
#'     threshold imposed. It tests whether the absolute value of the 
#'     log2 fold change is greater than the value specified as the \code{M}
#'     option.
#'      
#' @return A hicexp object with a filled in comparison slot.
#' @import edgeR
#' @importFrom data.table rbindlist
#' @export
#' @examples 
#' \dontrun{
#' data("hicexp_diff")
#' d <- model.matrix(~factor(meta(hicexp_diff)$group) + factor(c(1,2,1,2)))
#' hicexp_diff <- hic_glm(hicexp_diff, design = d, coef = 2)}
#' 
hic_glm <- function(hicexp, design, contrast = NA, coef = NA, 
                    method = "QLFTest", M = 1, p.method = "fdr", 
                    parallel = FALSE, max.pool = 0.7) {
  # match method
  method <- match.arg(method, c("LRTest", "QLFTest", "Treat"), 
                      several.ok = FALSE)
  # check to make sure hicexp is normalized
  if (!normalized(hicexp)) {
    warning("You should normalize the data before entering it into hic_glm")
  }
  # contrast & coef input
  if ( (is.na(contrast[1]) & is.na(coef[1])) || 
       (!is.na(contrast[1]) & !is.na(coef[1])) ) {
    stop("You must enter a value for contrast or a coef, but not both")
  }
  
  # First need to split up hic_table by chr and then by distance
  # split up data by chr
  table_list <- split(hic_table(hicexp), hic_table(hicexp)$chr)
  # for each chr create list of distance matrices
  table_list <- lapply(table_list, .get_dist_tables, max.pool = max.pool)
  # combine list of lists into single list of tables
  table_list <- do.call(c, table_list)
  # input each of the chr-distance tables into a DGElist object for edgeR
  dge_list <- lapply(table_list, .hictable2DGEList, 
                     covariates = meta(hicexp))
  # estimate dispersion for data
  dge_list <- smartApply(parallel, dge_list, edgeR::estimateDisp, 
                         design = design)

  
  # fit the GLM
  fit <- smartApply(parallel, dge_list, edgeR::glmQLFit, design = design)

  
  ## Perform test based on method and contrast/coef specified 
  
    # QL F-test test
    if (method == "QLFTest") {
      if (is.na(coef)) {
        result <- smartApply(parallel, fit, edgeR::glmQLFTest,
                                         contrast = contrast)
      } else {
        result <- smartApply(parallel, fit, edgeR::glmQLFTest,
                                         coef = coef)
      }
    }
    # Likelihood Ratio Test
    if (method == "LRTest") {
      if (is.na(coef)) {
        result <- smartApply(parallel, fit, edgeR::glmLRT,
                                         contrast = contrast)
      } else {
        result <- smartApply(parallel, fit, edgeR::glmLRT,
                                         coef = coef)
      }
    }
    # TREAT Analysis based on a minimum log2 fold change specified as M
    if (method == "Treat") {
      if (is.na(coef)) {
        result <- smartApply(parallel, fit, edgeR::glmTreat,
                                         contrast = contrast, lfc = M)
      } else {
        result <- smartApply(parallel, fit, edgeR::glmTreat,
                                         coef = coef, lfc = M)
      }
    }
  
  # format results for differentially interacting regions
  result <- mapply(.glm_reformat, result, table_list,
                   MoreArgs = list(p.method = p.method), SIMPLIFY = FALSE)
  result <- data.table::rbindlist(result)
  # sort comparison table
  result <- result[order(chr, region1, region2),]
  slot(hicexp, "comparison") <- data.table::as.data.table(result)
  
  
  return(hicexp)
}




## Background functions

# Reformat exact test results and adjust p-values
## !!! current p-value adjustment is taking place on per distance basis
.et_reformat <- function(et_result, hic_table, p.method) {
  # create table of location info and p-value results
  result <- cbind(hic_table[, c("chr", "region1", "region2", "D"), with = FALSE], et_result$table)
  colnames(result)[7] <-"p.value"
  # adjust p-values
  result$p.adj <- p.adjust(result$p.value, method = p.method)
  return(result)
}


# reformat results of GLM
.glm_reformat <- function(result, hic_table, p.method) {
  # create table of location info and p-value results
  result <- cbind(hic_table[, c("chr", "region1", "region2", "D"), with = FALSE], result$table)
  colnames(result)[ncol(result)] <-"p.value"
  # adjust p-values
  result$p.adj <- p.adjust(result$p.value, method = p.method)
  return(result)
}



# function to convert hic_table to a DGEList object
.hictable2DGEList <- function(hic_table, covariates) {
  # convert IFs into a matrix
  IFs <- as.matrix(hic_table[, -c("chr", "region1", "region2", "D"), with = FALSE])
  # create DGEList 
  dge <- DGEList(counts = IFs, samples = covariates)
  return(dge)
}

test_that('exact test works', {
  data("hicexp_diff", "HCT116_r1", "HCT116_r2", "HCT116_r3", "HCT116_r4")
  hicexp_new <- hic_exactTest(hicexp_diff)
  expect_gt(nrow(hicexp_new@comparison), 1)
  
  # test for errors on wrong input
  hicexp_new <- suppressWarnings(make_hicexp(HCT116_r1, 
                                             HCT116_r2, HCT116_r3,
                                             HCT116_r4, groups = c(1,2,3,3)))
  slot(hicexp_new, "normalized") <- TRUE
  # hicexp_new <- fastlo(hicexp_new, verbose = FALSE)
  expect_error(hic_exactTest(hicexp_new))
  
})


test_that('glm works', {
   data("hicexp2")
  hicexp_new <- fastlo(hicexp2, verbose = FALSE)
  d <- model.matrix(~factor(hicexp_new@metadata$group))
  hicexp_new <- hic_glm(hicexp_new, design = d, coef = 2, 
                        method = "QLFTest")
  expect_gt(nrow(hicexp_new@comparison), 1)
  
  # hicexp_new <- hic_glm(hicexp_new, design = d, coef = 2, 
  #                       method = "LRTest")
  # expect_gt(nrow(hicexp_new@comparison), 1)
  # 
  # hicexp_new <- hic_glm(hicexp_new, design = d, coef = 2, 
  #                       method = "Treat")
  # expect_gt(nrow(hicexp_new@comparison), 1)
  
  # test for errors on wrong input
  expect_error(hic_glm(hicexp_new, design = d, coef = 2,contrast = 1, 
                       method = "QLFTest"), 
               "You must enter a value for contrast or a coef, but not both")
  expect_error(hic_glm(hicexp_new, design = d, coef = NA,contrast = NA,
                       method = "QLFTest"), 
               "You must enter a value for contrast or a coef, but not both")
  
})

#' Perform library scaling on a hicexp object
#' 
#' @param hicexp A hicexp object.
#' @details This function will perform library scaling 
#'     on a hicexp object. Scaling is performed 
#'     separately for each chromosome. This is an 
#'     alternative normalization method to the
#'     cyclic loess and fastlo methods also
#'     provided in multiHiCcompare. Use this normalization
#'     method if for some reason you do not want to remove
#'     trends in the data and only want to normalize based
#'     on library size.
#' @importFrom data.table rbindlist
#' @export
#' @return A hicexp object.
#' @examples 
#' data("hicexp2")
#' hicexp2 <- hic_scale(hicexp2)
#' 
hic_scale <- function(hicexp) {
  # check if data already normalized
  if (normalized(hicexp)) {
    stop("Data has already been normalized.")
  }
  # extract hic_table
  tab <- hic_table(hicexp)
  # split up by chromosome
  tab <- split(tab, f = tab$chr)
  # scale each chr
  new_tab <- lapply(tab, .scale_chr)
  # recombine
  new_tab <- data.table::rbindlist(new_tab)
  slot(hicexp, "hic_table") <- new_tab
  slot(hicexp, "normalized") <- TRUE
  return(hicexp)
}



# internal function for scaling each chr
.scale_chr <- function(tab) {
  # extract IF matrix
  IFs <- as.matrix(tab[, -c("chr", "region1", "region2", "D")])
  # get min library size
  min.lib <- min(colSums(IFs)) 
  # perform scaling based on min lib size
  scaled_IFs <- apply(IFs, 2, function(x) {
    scale.factor <- sum(x) / min.lib
    new.IF <- x / scale.factor
    return(new.IF)
  })
  # recombine table
  new_table <- cbind(tab[, c('chr', 'region1', 'region2', 'D')], scaled_IFs)
  return(new_table)
}

#' Filter results of multiHiCcompare
#' 
#' @param hicexp A hicexp object which has been compared.
#' @param logfc_cutoff The logFC value you wish to filter
#'    by. Defaults to 1.
#' @param logcpm_cutoff The logCPM cutoff you wish to
#'    filter by. Defaults to 1.
#' @param p.adj_cutoff The adjusted p-value cutoff you wish to filter
#'    by. Defaults to 0.01.
#' @param D_cutoff The distance cutoff you wish to filter
#'    by. Interactions with a D < D_cutoff will be filtered.
#'    Defaults to 1. 
#' @param return_df The format for the data.frame returned
#'    by the function. Options are "bed" and "pairedbed" (Default).
#' @param pval_aggregate Method to aggregate region-specific p-values.
#' If a region differentially interacts with several other regions,
#' the p-values are aggregated using a 'max' method (Default, select maximum
#' p-value, most conservative), or the Fisher ('fisher'), Lancaster ('lancaster'),
#' or Sidak ('sidak') methods (see 'aggregate' package).
#' regions, it is assigned a single p-value aggregated from several 
#' @details This function is meant to filter the results of
#'     multiHiCcompare. The top differentially interacting 
#'     regions (DIRs) can be returned by using this function.
#'     When the return_df = "bed" option is set the resulting
#'     data.frame can be input into the plot_pvals or plot_counts
#'     functions to visualize the top DIRs. 
#' @return A data.table containing the filtered results.
#' @export
#' @import aggregation
#' @examples 
#' data('hicexp_diff')
#' topDirs(hicexp_diff)

topDirs <- function(hicexp, logfc_cutoff = 1, logcpm_cutoff = 1, p.adj_cutoff = 0.01,
                           D_cutoff = 1, return_df = "pairedbed", pval_aggregate = "max") { 
  # New in v.2.0 - remove alpha parameter
  # @param alpha The p-value cutoff for determining the count
  #     of number of times a region is significant. Used to calculate
  #     the number of times a region was detected as significantly interacting. 
  #     Defaults to 0.05.
  # alpha = 0.05, 
  # check that data has been compared
  if (nrow(results(hicexp)) < 1) {
    stop("Differences must be detected before making a manhattan plot.")
  }
  # check input
  return_df <- match.arg(return_df, c("bed", "pairedbed"), 
                      several.ok = FALSE)
  
  # make results object
  res <- results(hicexp)
  # filter (New in v2.0 - use global filtering)
  res <- res[logCPM >= logcpm_cutoff & abs(logFC) >= logfc_cutoff & p.adj <= p.adj_cutoff & D >= D_cutoff, ]
  
  # if pairedbed just need to filter
  if (return_df == "pairedbed") {
    # filter (Changed from v2.0 - use global filtering)
    # res <- res[logCPM >= logcpm_cutoff & abs(logFC) >= logfc_cutoff & p.adj <= p.adj_cutoff & D >= D_cutoff, ]
    # reformat
    res$chr1 <- paste0('chr', res$chr)
    res$chr2 <- paste0('chr', res$chr)
    res$end1 <- res$region1 + resolution(hicexp) - 1
    res$end2 <- res$region2 + resolution(hicexp) - 1
    res <- res[, c("chr1", "region1", "end1", 'chr2', 'region2', 'end2', 'D', 'logFC', 'logCPM', 'p.value', 'p.adj')]
    colnames(res)[c(2,5)] <- c('start1', 'start2')
    # make p-values in scientific notation
    res$p.value <- formatC(res$p.value, digits = 4, format = "E")
    res$p.adj <- formatC(res$p.adj, digits = 4, format = "E")
    # round logFc and logCPM
    res$logCPM <- round(res$logCPM, digits = 4)
    res$logFC <- round(res$logFC, digits = 4)
  }
  
  # if BED need to aggregate regions
  if (return_df == "bed") {
    # subset to only significant interactions (Changed from v2.0 - use global filtering)
    # res <- res[p.adj < alpha, ]
    # make vector of regions and p-values
    regions <- c(paste0(res$chr, ':', res$region1),
                 paste0(res$chr, ':', res$region2))
    p.values <- c(res$p.adj, res$p.adj)
    dist <- c(res$D, res$D)
    logfc <- c(res$logFC, res$logFC)
    logcpm <- c(res$logCPM, res$logCPM)
    
    
    # aggregate into fisher pvalue
    # fisher_aggregate <- aggregate(p.values, 
    #                               by = list(regions), 
    #                               FUN = function(x) {
    #                                 if (length(x) > 1) {
    #                                   metap::sumlog(x)$p
    #                                 } else {
    #                                   x
    #                                 }
    #                               })
    
    # Use addCLT instead of fisher method
    fisher_aggregate <- aggregate(p.values, 
                                  by = list(regions), 
                                  FUN = function(x) {
                                    if (length(x) > 1) {
                                      if (pval_aggregate == "max") {
                                        max(x, na.rm = TRUE)
                                      } else if (pval_aggregate == "fisher") {
                                        aggregation::fisher(x)
                                      } else if (pval_aggregate == "lancaster") {
                                        aggregation::lancaster(x)
                                      } else if (pval_aggregate == "sidak") {
                                        aggregation::sidak(x)
                                      }
                                    } else {
                                      x
                                    }
                                  })
    
    fisher_aggregate <- cbind(read.table(text = fisher_aggregate$Group.1, 
                                         sep = ":"), fisher_aggregate$x)
    fisher_aggregate$`fisher_aggregate$x`[fisher_aggregate$`fisher_aggregate$x` == 0] <- .Machine$double.xmin
    # # aggregate into stouffer pvalue
    # p.values[p.values == 1] <- 0.99999 # change pvalues from 1 so sumz works correctly
    # stouffer_liptak_aggregate <- aggregate(p.values, 
    #                                        by = list(regions), 
    #                                        FUN = function(x) {
    #                                          if (length(x) > 1) {
    #                                            suppressWarnings(metap::sumz(x)$p) 
    #                                          } else {
    #                                            x
    #                                          }
    #                                        })
    # 
    # stouffer_liptak_aggregate <- cbind(read.table(text = stouffer_liptak_aggregate$Group.1,
    #                                               sep = ":"), stouffer_liptak_aggregate$x)
    
    # aggregate counts
    count <- ifelse(p.values < p.adj_cutoff, 1, 0)
    count_aggregate <- aggregate(count, by = list(regions), sum)
    count_aggregate <- cbind(read.table(text = count_aggregate$Group.1, sep = ":"),
                             count_aggregate$x)
    
    # aggregate D
    dist_aggregate <- aggregate(dist, by = list(regions), mean)
    dist_aggregate <- cbind(read.table(text = dist_aggregate$Group.1, sep = ":"),
                             dist_aggregate$x)
    # aggregate logfc
    logfc_aggregate <- aggregate(logfc, by = list(regions), mean)
    logfc_aggregate <- cbind(read.table(text = logfc_aggregate$Group.1, sep = ":"),
                             logfc_aggregate$x)
    # aggregate logcpm
    logcpm_aggregate <- aggregate(logcpm, by = list(regions), mean)
    logcpm_aggregate <- cbind(read.table(text = logcpm_aggregate$Group.1, sep = ":"),
                             logcpm_aggregate$x)
    # Format results
    res <- dplyr::left_join(count_aggregate, dist_aggregate, by = c('V1' = 'V1', 'V2' = 'V2'))
    res <- dplyr::left_join(res, logfc_aggregate, by = c('V1' = 'V1', 'V2' = 'V2'))
    res <- dplyr::left_join(res, logcpm_aggregate, by = c('V1' = 'V1', 'V2' = 'V2'))
    # res <- dplyr::left_join(res, stouffer_liptak_aggregate, by = c('V1' = 'V1', 'V2' = 'V2'))
    res <- dplyr::left_join(res, fisher_aggregate, by = c('V1' = 'V1', 'V2' = 'V2'))
    res$V1 <- paste0('chr', res$V1)
    res$end <- res$V2 + resolution(hicexp) - 1
    colnames(res) <- c('chr', 'start', 'count', 'avgD', 'avgLogFC', 'avgLogCPM',  'avgP.adj', 'end')
    res <- res[, c('chr', 'start', 'end', 'count', 'avgD', 'avgLogFC', 'avgLogCPM',  'avgP.adj')]
    res <- data.table::as.data.table(res)
    res <- res[order(res$count, decreasing = TRUE), ]
    
    # filter (Changed from v2.0 - use global filtering)
    # res <- res[avgLogCPM >= logcpm_cutoff & abs(avgLogFC) >= logfc_cutoff & avgP.adj <= p.adj_cutoff & avgD >= D_cutoff, ]
    
    # format pvalues
    res$avgP.adj <- formatC(res$avgP.adj, digits = 4, format = "E")
    # round logFc and logCPM
    res$avgLogCPM <- round(res$avgLogCPM, digits = 4)
    res$avgLogFC <- round(res$avgLogFC, digits = 4)
  }
  
  return(res)
}

#' Cyclic Loess normalization for Hi-C data
#' 
#' @param hicexp A hicexp object
#' @param iterations The number of iterations (cycles) 
#'     of loess normalization to perform. Defaults to 3.
#' @param span The span for loess normalization. Defaults to
#'     NA indicating that span will be automatically calculated
#'     using generalized cross validation.
#' @param parallel Logical. Should parallel processing be used?
#' @param verbose Logical. Should messages about loess normalization
#'     be printed to the screen.
#' 
#' @details This function performs cyclic loess normalization
#'    on a Hi-C experiment. multiHiCcompare's cyclic loess procedure
#'    is a modified version of Ballman's (2004) cyclic loess and
#'    the joint loess normalization used in the original HiCcompare.
#'    For each unique pair of samples in the hicexp object an MD plot
#'    is generated. A loess curve is fit to the MD plot and then the 
#'    fitted values are used to adjust the data. This is performed on
#'    all unique pairs and then repeated until convergence. 
#' @return A hicexp object that has been normalized. 
#' @export
#' @importFrom BiocParallel bplapply
#' @importFrom HiCcompare MD.plot1
#' @importFrom data.table rbindlist
#' @importFrom stats aggregate loess loess.control model.matrix 
#'     optimize p.adjust predict update D loess.smooth
#' @importFrom utils combn read.table tail write.table
#' @examples 
#' #' data("hicexp2")
#' hicexp2 <- cyclic_loess(hicexp2, span = 0.7)


cyclic_loess <- function(hicexp, iterations = 3, span = NA, 
                         parallel = FALSE, verbose = FALSE) {
  # check if data already normalized
  if (normalized(hicexp)) {
    stop("Data has already been normalized.")
  }
  # check span input
  if (!is.na(span)) {
    if (!is.numeric(span) || span <= 0 || span > 1) {
      stop("span must be set to NA or a value between 0 and 1")
    }
  }
  # check iterations input
  if (iterations != 3L) {
    warning("Typically it takes about 3 iterations for cyclic 
            loess to converge.")
  }
  # check for missing values
  if (any(is.na(hic_table(hicexp)))) {
    stop("hic_table contains missing values!")
  }
  # split up data by condition and perform cyclic loess
  normalized <- .loess_condition(hic_table(hicexp), 
                                 iterations = iterations, parallel = parallel, 
                                 verbose = verbose, span = span)
  # sort hic_table
  normalized <- normalized[order(chr, region1, region2),]
  # put back into hicexp object
  slot(hicexp, "hic_table") <- normalized
  slot(hicexp, "normalized") <- TRUE
  
  
  return(hicexp)
}




# background functions
### Perform cyclic loess for a condition
.loess_condition <- function(hic_table, iterations, parallel, verbose, span) {
  # split up data by chr
  table_list <- split(hic_table, hic_table$chr)
  # plug into parallelized loess function
  normalized <- smartApply(parallel, table_list, .cloess, 
                           iterations = iterations, verbose = verbose,
                           span = span)
  
  # recombine tables
  normalized <- data.table::rbindlist(normalized)
  return(normalized)
}

# perform cyclic loess on a table 
.cloess <- function(tab, iterations, verbose, span, degree = 1, 
                    loess.criterion = "gcv") {
  # make matrix of IFs
  IF_mat <- as.matrix(tab[, -c("chr", "region1", "region2", "D"), with = FALSE])
  # make index matrix
  idx_mat <- IF_mat
  idx_mat[idx_mat != 0] <- 1
  # log the matrix
  IF_mat <- log2(IF_mat + 1)
  n <- ncol(IF_mat)
  # begin cyclic loess
  for (i in seq(from = 1, to = iterations)) {
    for(j in seq(from = 1, to = (n-1))) {
      for (k in seq(from = (j+1), to = n)) {
        # # get rows with zeros
        # zeros1 <-  IF_mat[,k] == 0
        # zeros2 <- IF_mat[,j] == 0
        # zeros <- zeros1 | zeros2
        # M <- IF_mat[!zeros, k] - IF_mat[!zeros, j]
        # D <- tab$D[!zeros]
        M <- IF_mat[,k] - IF_mat[,j]
        D <- tab$D
        if (is.na(span)) {
          l <- .loess.as(x = D, y = M, degree = degree, 
                         criterion = loess.criterion,
                         control = loess.control(surface = "interpolate",
                                                 statistics = "approximate", 
                                                 trace.hat = "approximate"))
        } else {
          l <- .loess.as(x = D, y = M, degree = degree, user.span = span,
                         criterion = loess.criterion,
                         control = loess.control(surface = "interpolate",
                                                 statistics = "approximate", 
                                                 trace.hat = "approximate"))
        }
        # calculate gcv and AIC
        traceL <- l$trace.hat
        sigma2 <- sum(l$residuals^2)/(l$n - 1)
        aicc <- log(sigma2) + 1 + 2 * (2 * (traceL + 1))/(l$n - traceL -2)
        gcv <- l$n * sigma2/(l$n - traceL)^2
        # print the span picked by gcv
        if (verbose) {
          message("Span for loess: ", l$pars$span)
          message("GCV for loess: ", gcv)
          message("AIC for loess: ", aicc)
        }
        # adjust IFs
        # IF_mat[!zeros,j] <- IF_mat[!zeros,j] + l$fitted/2
        # IF_mat[!zeros,k] <- IF_mat[!zeros,k] - l$fitted/2
        IF_mat[,j] <- IF_mat[,j] + l$fitted/2
        IF_mat[,k] <- IF_mat[,k] - l$fitted/2
      }
    }
  }
  # anti-log IFs
  IF_mat <- (2^IF_mat) - 1
  # reset zeros
  IF_mat <- IF_mat * idx_mat
  # set negative values to 0
  IF_mat[IF_mat < 0] <- 0
  # fix any potential Infs or NaN's
  IF_mat[is.nan(IF_mat)] <- 0
  IF_mat[is.infinite(IF_mat)] <- 0
  # recombine table
  tab <- cbind(tab[, 1:4, with = FALSE], IF_mat)
  return(tab)
}



# loess with Automatic Smoothing Parameter Selection adjusted possible
# range of smoothing originally from fANCOVA package
.loess.as <- function(x, y, degree = 1, criterion = c("aicc", "gcv"),
                      family = c("gaussian",
                                 "symmetric"), user.span = NULL, plot = FALSE, ...) {
  criterion <- match.arg(criterion)
  family <- match.arg(family)
  x <- as.matrix(x)

  data.bind <- data.frame(x = x, y = y)
  if (ncol(x) == 1) {
    names(data.bind) <- c("x", "y")
  } else {
    names(data.bind) <- c("x1", "x2", "y")
  }
  
  opt.span <- function(model, criterion = c("aicc", "gcv"),
                       span.range = c(0.01, 0.9)) {
    as.crit <- function(x) {
      span <- x$pars$span
      traceL <- x$trace.hat
      sigma2 <- sum(x$residuals^2)/(x$n - 1)
      aicc <- log(sigma2) + 1 + 2 * (2 * (traceL + 1))/(x$n - traceL -
                                                          2)
      gcv <- x$n * sigma2/(x$n - traceL)^2
      result <- list(span = span, aicc = aicc, gcv = gcv)
      return(result)
    }
    criterion <- match.arg(criterion)
    fn <- function(span) {
      mod <- stats::update(model, span = span)
      as.crit(mod)[[criterion]]
    }
    result <- optimize(fn, span.range)
    return(list(span = result$minimum, criterion = result$objective))
  }
  
  if (ncol(x) == 1) {
    if (is.null(user.span)) {
      fit0 <- loess(y ~ x, degree = degree, family = family, data = data.bind,
                    ...)
      span1 <- opt.span(fit0, criterion = criterion)$span
    } else {
      span1 <- user.span
    }
    fit <- loess(y ~ x, degree = degree, span = span1, family = family,
                 data = data.bind, ...)
  } else {
    if (is.null(user.span)) {
      fit0 <- loess(y ~ x1 + x2, degree = degree, family = family,
                    data.bind, ...)
      span1 <- opt.span(fit0, criterion = criterion)$span
    } else {
      span1 <- user.span
    }
    fit <- loess(y ~ x1 + x2, degree = degree, span = span1, family = family,
                 data = data.bind, ...)
  }
  if (plot) {
    if (ncol(x) == 1) {
      m <- 100
      x.new <- seq(min(x), max(x), length.out = m)
      fit.new <- predict(fit, data.frame(x = x.new))
      plot(x, y, col = "lightgrey", xlab = "x", ylab = "m(x)", ...)
      lines(x.new, fit.new, lwd = 1.5, ...)
    } else {
      m <- 50
      x1 <- seq(min(data.bind$x1), max(data.bind$x1), len = m)
      x2 <- seq(min(data.bind$x2), max(data.bind$x2), len = m)
      x.new <- expand.grid(x1 = x1, x2 = x2)
      fit.new <- matrix(predict(fit, x.new), m, m)
      persp(x1, x2, fit.new, theta = 40, phi = 30, ticktype = "detailed",
            xlab = "x1", ylab = "x2", zlab = "y", col = "lightblue",
            expand = 0.6)
    }
  }
  return(fit)
}

test_that('cyclic_loess works', {
  data("hicexp2")
  hicexp_new <- cyclic_loess(hicexp2, 
                             span = 0.5, verbose = FALSE)
  expect_equal(hicexp_new@normalized, TRUE)
  
  # test for errors on wrong input
  expect_error(cyclic_loess(hicexp_new), 
               "Data has already been normalized.")
  data('hicexp2')
  expect_error(cyclic_loess(hicexp2, span = 0),
               "span must be set to NA or a value between 0 and 1")
  expect_error(cyclic_loess(hicexp2, span = 2), 
               "span must be set to NA or a value between 0 and 1")
})


test_that('fastlo works', {
  data("hicexp2")
  hicexp_new <- fastlo(hicexp2, verbose = FALSE)
  expect_equal(hicexp_new@normalized, TRUE)
  
  # test for errors on wrong input
  expect_error(fastlo(hicexp_new),
               "Data has already been normalized.")
  data('hicexp2')
  expect_error(fastlo(hicexp2, span = 0), 
               "span must be set to NA or a value between 0 and 1")
  expect_error(fastlo(hicexp2, span = 2), 
               "span must be set to NA or a value between 0 and 1") 
})

#' Export multiHiCcompare results for visualization in Juicebox
#' 
#' @param hicexp A hicexp object which has been compared.
#' @param logfc_cutoff The logFC value you wish to filter
#'    by. Defaults to 1.
#' @param logcpm_cutoff The logCPM cutoff you wish to
#'    filter by. Defaults to 1.
#' @param p.adj_cutoff The adjusted p-value cutoff you wish to filter
#'    by. Defaults to 0.01.
#' @param D_cutoff The distance cutoff you wish to filter
#'    by. Interactions with a D < D_cutoff will be filtered.
#'    Defaults to 1. 
#' @param file_name The file name of the text file to be saved.
#' @param color A decimal RGB color code. Should be a character
#'     value in form of "0,0,255". Defaults to color code for
#'     blue. This will determine the color of the annotations
#'     on the Juicebox heatmap. 
#' @details This function is meant to filter the results of
#'     multiHiCcompare and export the significant 
#'     differentially interacting regions into a text file which
#'     can be imported into Juicebox as a 2D annotations file. This
#'     will allow you to visualize where your DIRs occur on the heatmap
#'     of the interactions. Please see the included vignette on using
#'     Juicebox to visualize multiHiCcompare results. This can be accessed
#'     with browseVignettes("multiHiCcompare").
#' @return A text file containing annotations for input into Juicebox.
#' @export
#' @examples 
#' data('hicexp_diff')
#' exportJuicebox(hicexp_diff, file_name = "juiceboxAnnotations.txt") 

exportJuicebox <- function(hicexp, logfc_cutoff = 1, logcpm_cutoff = 1, p.adj_cutoff = 0.01,
                           D_cutoff = 1, file_name = "juiceboxAnnotations.txt",
                           color = "0,0,255") {
  # check that data has been compared
  if (nrow(results(hicexp)) < 1) {
    stop("Differences must be detected before making a manhattan plot.")
  }
  # make results object
  res <- results(hicexp)
  # filter
  res <- res[logCPM >= logcpm_cutoff & abs(logFC) >= logfc_cutoff & p.adj <= p.adj_cutoff & D >= D_cutoff, ]
  # reformat
  res$chr1 <- paste0('chr', res$chr)
  res$chr2 <- paste0('chr', res$chr)
  res$end1 <- res$region1 + resolution(hicexp) #- 1
  res$end2 <- res$region2 + resolution(hicexp) #- 1
  # res <- res[, c("chr1", "region1", "region2", 'chr2', 'end1', 'end2')]
  res <- res[, c("chr1", "region1", "end1", 'chr2', 'region2', 'end2')]
  res <- res[order(res$chr1, res$region1, res$region2)]
  res$color <- color
  res$comment <- "significant differentially interacting region"
  colnames(res) <- c('chr1', 'x1', 'x2', 'chr2', 'y1', 'y2', 'color', 'comment')
  write.table(res, file = file_name, quote = FALSE, sep = '\t', row.names = FALSE, col.names = TRUE)
}

#' Perform fast loess normalization on a Hi-C experiment
#' 
#' @param hicexp A hicexp object
#' @param iterations The number of iterations (cycles) 
#'     for fastlo to proceed through.
#' @param span The span of loess fitting. Defaults to 0.7. To
#'     automatically calculate a span using the GCV set 
#'     span = NA. However note that setting span = NA will
#'     significantly slow down the normalization process.
#' @param parallel Logical. Should parallel processing be
#'     used?
#' @param verbose Logical, should messages about
#'     the normalization be printed?
#' @param max.pool The proportion of unit distances after
#'     which all further distances will be pooled. Distances
#'     before this value will be progressively pooled and
#'     any distances after this value will be combined
#'     into a single pool. Defaults to 0.7. Warning: do
#'     not adjust this value from the default unless you
#'     are getting errors related to the lfproc function
#'     or due to sparsity in fastlo normalization. If these
#'     errors occur it is due to either sparsity or low 
#'     variance and max.pool will need to be lowered; 
#'     typically to 0.5 or 0.6. 
#' 
#' @details This function performs the fast loess (fastlo)
#'    normalization procedure on a hicexp object. the fast linear 
#'    loess ("fastlo") method 
#'    of Ballman (2004) that is adapted to Hi-C data on a per-distance basis.
#'     To perform 
#'    "fastlo" on Hi-C data we first split the data into p pooled matrices. 
#'    The "progressive pooling" is used to split up the Hi-C matrix by unit 
#'    distance. Fastlo
#'    is then performed on the MA plots for each distance pool. 
#'    See Stansfield et al (2018)
#'    for full description. 
#'   
#' @return A hicexp object that is normalized.
#' @export
#' @importFrom BiocParallel bplapply
#' @importFrom dplyr left_join
#' @importFrom data.table rbindlist
#' @examples 
#' data("hicexp2")
#' hicexp2 <- fastlo(hicexp2)

fastlo <- function(hicexp, iterations = 3, span = 0.7, parallel = FALSE, 
                   verbose = FALSE, max.pool = 0.7) {
  # check if data already normalized
  if (normalized(hicexp)) {
    stop("Data has already been normalized.")
  }
  # check span input
  if (!is.na(span)) {
    if (!is.numeric(span) || span <= 0 || span > 1) {
      stop("span must be set to NA or a value between 0 and 1")
    }
  }
  # check iterations input
  if (iterations != 3L) {
    warning("Typically it takes about 3 iterations for 
            cyclic loess to converge.")
  }

  # input conditions to fastlo
  normalized <- .fastlo_condition(hic_table(hicexp), 
                                  iterations = iterations, span = span, 
                                  parallel = parallel, verbose = verbose, 
                                  max.pool = max.pool)
  # sort hic_table
  normalized <- normalized[order(chr, region1, region2),]
  # put back into hicexp object
  slot(hicexp, "hic_table") <- normalized
  slot(hicexp, "normalized") <- TRUE

  
  return(hicexp)
}

# background functions

# perform fastlo on a condition
.fastlo_condition <- function(hic_table, iterations, span, 
                              parallel, verbose, max.pool) {
  # split up data by chr
  table_list <- split(hic_table, hic_table$chr)
  # for each chr create list of distance matrices
  table_list <- lapply(table_list, .get_dist_tables, max.pool = max.pool)
  # combine list of lists into single list of tables
  table_list <- do.call(c, table_list)
  # apply fastlo to list
  normalized <- smartApply(parallel, table_list, .fastlo, span = span, 
                                      iterations = iterations)
  
  # recombine list of tables
  hic_table <- rbindlist(normalized)
  return(hic_table)
}


## This is the new version where we use progressive pooling of distances
# make list of tables by distance pool
.get_dist_tables <- function(chr_table, max.pool) {
  # check for correct max.pool input
  if (!is.numeric(max.pool)) {
    stop("max.pool must be a numeric value between 0 and 1")
  }
  if (max.pool < 0 || max.pool > 1) {
    stop("max.pool must be between 0 and 1")
  }
  if (max.pool < 0.5) {
    warning("Setting max.pool < 0.5 may cause issues")
  }
  if (max.pool > 0.7) {
    warning("Setting max.pool > 0.7 may cause issues")
  }
  D <- sort(unique(chr_table$D)) 
  # use triangular number series to solve for number of pools
  x <- length(D)
  n <- (sqrt((8 * x) + 1) - 1) / 2
  n <- ceiling(n)
  pools <- rep(D[1:n], 1:n)[1:x]
  # add the pools column to the data.table corresponding to the distances
  id.df <- as.data.frame(cbind(D, pools))
  # get maximum distance
  dist_max <- ceiling(max.pool * nrow(id.df))
  # combine pools for everything at or above maximum distance
  pool_max <- id.df[dist_max,2] 
  id.df[id.df$pools >= pool_max,2] <- pool_max
  table_by_dist <- data.table::as.data.table(left_join(chr_table, id.df, by = c("D" = "D")))
  # split up tables by pool
  table_by_dist <- split(table_by_dist, table_by_dist$pools)
  # drop pools column
  table_by_dist <- lapply(table_by_dist, function(x) x[, pools := NULL])
  # check number of rows per table
  table_by_dist <- .check_tables(table_by_dist)
  return(table_by_dist)
}

# check to make sure number of rows for each table is not less than 500
.check_tables <- function(table_by_dist) {
  min.row <- 500
  # get row numbers
  row.nums <- lapply(table_by_dist, nrow)
  # find which tables have number of rows < min.row
  small_D <- which(row.nums < min.row)
  # check if any tables have less than min.row
  if (length(small_D) > 0) {
    while (length(small_D) > 0) {
      i <- small_D[1]
      # check if first distance has less than min.row
      if(i==length(table_by_dist)){ # if it reach to the end, forget it
        return(table_by_dist)
      }
      if (table_by_dist[[i]]$D[1] == 0 | i==1) { # if i==1, it is the first one
        new_table <- rbind(table_by_dist[[i]], table_by_dist[[i+1]])
        table_by_dist[[i]] <- new_table
        table_by_dist[[i+1]] <- NA
      } else{
           # otherwise combine with previous table
           new_table <- rbind(table_by_dist[[i-1]], table_by_dist[[i]])
           table_by_dist[[i-1]] <- new_table
           table_by_dist[[i]] <- NA
      }
      # remove NAs
      table_by_dist <- table_by_dist[!is.na(table_by_dist)]
      # update row numbers
      row.nums <- lapply(table_by_dist, nrow)
      # update which tables have number of rows < min.row
      small_D <- which(row.nums < min.row)
    }
    return(table_by_dist)
  } else {
    return(table_by_dist)
  }
}



# perform fastlo on table
.fastlo <- function(tab, span, iterations, loess.criterion = "gcv", degree = 1) {
  # make matrix of IFs
  IF_mat <- as.matrix(tab[, -c("chr", "region1", "region2", "D"), with = FALSE])
  # make indicator matrix
  idx_mat <- IF_mat
  idx_mat[idx_mat != 0] <- 1
  # log the IF matrix
  IF_mat <- log2(IF_mat + 1)
  n <- ncol(IF_mat)
  # outer loop for number of cycles
  for (i in seq(from = 1, to = iterations)) {
    # calculate rowmeans (A) 
    A <- rowMeans(IF_mat, na.rm = TRUE)
    for (j in seq(from = 1, to = n)) {
      M <- IF_mat[,j] - A
      # fit loess curve
      if (is.na(span)) {
        f <- .loess.as(x = A, y = M, degree = degree, 
                       criterion = loess.criterion,
                       control = loess.control(surface = "interpolate",
                                               statistics = "approximate",
                                               trace.hat = "approximate"))
      } else {
        f <- .loess.as(x = A, y = M, degree = degree, user.span = span,
                       criterion = loess.criterion,
                       control = loess.control(surface = "interpolate",
                                               statistics = "approximate",
                                               trace.hat = "approximate"))
      }
      # adjust 
      IF_mat[,j] <- IF_mat[,j] - f$fitted
    }
  }
  # anti-log the IF_mat
  IF_mat <- (2^IF_mat) - 1
  # revert zeros
  IF_mat <- IF_mat * idx_mat
  # deal with negative values after normalization
  IF_mat[IF_mat < 0] <- 0
  # fix any potential Infs or NaN's
  IF_mat[is.nan(IF_mat)] <- 0
  IF_mat[is.infinite(IF_mat)] <- 0
  # rebuild table
  tab <- cbind(tab[, c('chr', 'region1', 'region2', 'D'), with = FALSE], IF_mat)
  return(tab)
}

#' Perform a permutation test to check enrichment of a genomic
#'     feature with DIRs detected by multiHiCcompare
#'    
#' @param hicexp A Hicexp object which has been compared.  
#' @param feature A GRanges object containing locations for
#'     a genomic feature you would like to test for enrichment
#'     in the differentially interacting regions (DIRs).
#' @param p.adj_cutoff The adjusted p-value cutoff for
#'      declaring a region significant. See ?topDirs for
#'      more information. Defaults to 10^-10
#' @param logfc_cutoff The log fold change cutoff for
#'      a region to be declared significant. See ?topDirs
#'      for more information. Defaults to 1.
#' @param num.perm The number of permutations to run.
#'      Defaults to 1000. 
#' @param pval_aggregate Method to aggregate region-specific p-values.
#' If a region differentially interacts with several other regions,
#' the p-values are aggregated using a 'max' method (Default, select maximum
#' p-value, most conservative), or the Fisher ('fisher'), Lancaster ('lancaster'),
#' or Sidak ('sidak') methods (see 'aggregate' package).
#' regions, it is assigned a single p-value aggregated from several. See ?topDirs
#' @return The permutation p-value
#' @export
#' @importFrom GenomicRanges makeGRangesFromDataFrame findOverlaps GRanges
#' @importFrom GenomeInfoDb seqlevelsStyle
#' @importFrom stats start end
#' @import GenomeInfoDbData
#' @examples 
#' \dontrun{
#' data("hicexp_diff")
#' data("hg19_cyto")
#' perm_test(hicexp_diff, hg19_cyto)
#' }

perm_test <- function(hicexp, feature, p.adj_cutoff = 10^-10, logfc_cutoff = 1, num.perm = 1000, pval_aggregate = "max") {
  # check that feature is a GRanges object
  if (!is(feature, "GRanges")) {
    stop("feature must be a GRanges object")
  }
  # convert seqnames of feature to include chr
  GenomeInfoDb::seqlevelsStyle(feature) <- "UCSC"
  # check that data has been compared
  if (nrow(results(hicexp)) < 1) {
    stop("Differences must be detected before making a manhattan plot.")
  }
  
  # make a GRanges object for the DIRs
  sig.regions <- topDirs(hicexp, logfc_cutoff = logfc_cutoff, p.adj_cutoff = p.adj_cutoff, return_df = 'bed') 
  sig.regions <- makeGRangesFromDataFrame(sig.regions, 
                                             seqnames.field = 'chr', 
                                             start.field = 'start', 
                                             end.field = 'end',
                                             keep.extra.columns = TRUE)
  
  # find overlaps between feature and sig.regions
  olaps <- findOverlaps(sig.regions, feature)
  message("There are ", length(olaps), " overlaps between your genomic feature and the significant regions")
  
  # If 0 overlaps return p-value of 1
  if (length(olaps) < 1) {
    return(1)
  }
  
  # set up permutation test
  sample.size <- length(sig.regions) # Number of DIRs
  n.olap      <- length(olaps) # How many of them overlap with DE genes
  num.olap    <- vector(mode = "numeric", length = num.perm) # A vector to store the number of overlaps during permutations
  
  # make background regions GRanges object
  regions <- topDirs(hicexp, logfc_cutoff = 0, logcpm_cutoff = -10,
                     D_cutoff = 0, p.adj_cutoff = 1, 
                     return_df = 'bed', pval_aggregate = "max") 
  # Order regions
  regions <- regions[order(chr, start, end), ]
  # Remove unnecessary columns
  regions <- regions[, c('chr', 'start', 'end')]
  
  # perform permutation test
  for(i in 1:num.perm) {
    # Select random regions from the genome of the same size as DIRs
    sampled <- sample(1:nrow(regions), sample.size) 
    sampled.regions <- regions[sampled, ]
    sampled.gr <- GRanges(sampled.regions$chr, 
                          IRanges(start = sampled.regions$start, 
                                  end = sampled.regions$end))
    # Find how many times they overlap with DE genes
    tmp.olap <- findOverlaps(sampled.gr, feature)
    # Keep the results
    num.olap[i] <- length(tmp.olap)
  }
  # Calculate permutation p-value
  p.value <- (sum(num.olap > n.olap) + 1) / (num.perm + 1)
  return(p.value)
}

#' Perform filtering on a Hi-C experiment
#' 
#' @param hicexp A hicexp object.
#' @param zero.p The proportion of zeros in a row to filter by. 
#'     If the proportion of zeros in a row is <= zero.p
#'     the row will be filtered out, i.e. zero.p = 1 means
#'     nothing is filtered based on zeros and zero.p = 0 
#'     will filter rows that have any zeros.
#' @param A.min The minimum average expression value
#'     (row mean) for an interaction pair. If the 
#'     interaction pair has an average expression 
#'     value less than A.min the row will be filtered
#'     out.
#' @param remove.regions A GenomicRanges object indicating
#'     specific regions to be filtered out. By default
#'     this is the hg19 centromeric, gvar, and stalk
#'     regions. Also included in the package is
#'     hg38_cyto. If your data is not hg19 you will 
#'     need to substitute this file. To choose not 
#'     to filter any regions set regions = NULL.
#' @details This function is used to filter out
#'     the interactions that have low average IFs
#'     or large numbers of 0 IF values. If you have
#'     already performed filtering when making your
#'     hicexp object do not use this again. As these
#'     interactions are not very interesting and
#'     are commonly false positives during difference
#'     detection it is better to remove them from
#'     the dataset. Additionally, filtering will
#'     help speed up the run time of multiHiCcompare. 
#'     Filtering can be performed before or after 
#'     normalization, however the best computational
#'     speed gain will occur when filtering is done
#'     before normalization.
#' @return A hicexp object.
#' @export
#' @importFrom GenomicRanges makeGRangesFromDataFrame findOverlaps pos
#' @examples 
#' data("hicexp2")
#' hicexp2 <- hic_filter(hicexp2)

hic_filter <- function(hicexp, zero.p = 0.8, A.min = 5, remove.regions = hg19_cyto) {
  if (zero.p < 0 || zero.p > 1) {
    stop("zero.p must be in [0,1]")
  }
  if (A.min < 0) {
    stop("A.min must be >= 0")
  }
  # make matrix of IFs
  IF_mat <- as.matrix(hic_table(hicexp)[, -c("chr", "region1", "region2", "D"), with = FALSE])
  # get row Avg expression
  A <- apply(IF_mat, 1, mean)
  # filter by Avg expression of interacting pair
  keep.A <- A > A.min
  # filter by proportion of zero IFs for each interaction pair
  zeros <- rowSums(IF_mat == 0) / ncol(IF_mat) # proportion of zeros by row
  keep.z <- zeros <= zero.p
  # final keep vector
  keep <- keep.A & keep.z
  # filter table
  slot(hicexp, "hic_table") <- hic_table(hicexp)[keep,]
  
  ## TODO: make this generalizable to any genome
  if(!is.null(remove.regions)) {
    # filter out hg19 acen, gvar, stalk regions
    tab <- hic_table(hicexp)
    # make GRanges object for regions of hic_table
    region1 <- tab[, c('chr', 'region1')]
    region1[, `:=`(end = region1 + resolution(hicexp) - 1)]
    region2 <- tab[, c('chr', 'region2')]
    region2[, `:=`(end = region2 + resolution(hicexp) - 1)]
    region1 <- GenomicRanges::makeGRangesFromDataFrame(region1, seqnames.field = 'chr', start.field = 'region1', end.field = 'end')
    region2 <- GenomicRanges::makeGRangesFromDataFrame(region2, seqnames.field = 'chr', start.field = 'region2', end.field = 'end')
    # overlap
    olaps1 <- GenomicRanges::findOverlaps(region1, remove.regions)
    olaps2 <- GenomicRanges::findOverlaps(region2, remove.regions)
    remove <- unique(c(olaps1@from, olaps2@from))
    # filter table
    if (length(remove) > 0) {
      slot(hicexp, "hic_table") <- hic_table(hicexp)[-remove,]
    }
  }
  
  return(hicexp)
}

#' Manhattan plot function for results of multiHiCcompare
#' 
#' @param hicexp A hicexp object that has had differences
#'     detected
#' @param pval_aggregate string denoting the p-value method to
#'     use for plotting. Options are "standard", "fisher",
#'     "lancaster", "sidak", and "count". "standard" plots a manhattan plot
#'     using all individual p-values (very slow, use with caution).  
#'     "fisher", "lancaster", or "sidak" methods use the Fisher's, Lancaster,
#'     or the Sidak method, respectively, for combining p-values
#'     for each region which are then plotted on the -log10(p-value) Y-axis.
#'     "count" summarizes the number of times a region was detected as 
#'     significant (see "p.adj_cutoff" parameter), plotted on Y-axis. The higher
#'     the dots are, the more significant/more frequent a region was 
#'     detected as significantly differentially interacting. See ?topDirs
#' @param return_df Logical, should the data.frame used to
#'     generate the plot be returned?
#' @param p.adj_cutoff The adjusted p-value cutoff to be used for 
#'     calling an interaction significant. This is
#'     only used if method = 'count'. Defaults to 
#'     0.05.
#' @param plot.chr A numeric value indicating a specific
#'     chromosome number to subset the plot to. Defaults
#'     to NA indicating that all chromosomes will be plotted.
#' @details This function is used to create a manhattan
#'     plot for the significance of all genomic regions 
#'     in the dataset. These correspond to the rows (or columns)
#'     of the upper triangle of the full Hi-C matrix. Each genomic
#'     region of the Hi-C dataset has multiple interactions it
#'     is involved in and the significance of all of these can 
#'     be visualized with \code{pval_aggregate = "standard"}. 
#'     Alternatively the p-values for all these interactions
#'     can be combined using either Fisher's, or the Lancaster or the
#'     Sidac method of combining p-values. Additionally
#'     the "count" option will plot based on the number of times
#'     each region was found to be involved in a signficantly 
#'     different interaction. The 
#'     manhattan plot can be used to identify "hotspot"
#'     regions of the genome where major differences
#'     seem to be located based on the results of a multiHiCcompare
#'     analysis.
#' @return A manhattan plot and optionally the data.frame used
#'     to generate the manhattan plot.
#' @importFrom qqman manhattan
#' @import aggregation
#' @export
#' @examples
#' data("hicexp_diff")
#' manhattan_hicexp(hicexp_diff, pval_aggregate = "fisher")


manhattan_hicexp <- function(hicexp, pval_aggregate = "standard", return_df = FALSE, 
                             p.adj_cutoff = 0.05, plot.chr = NA) {
  # check input
  pval_aggregate <- match.arg(pval_aggregate, c("standard", "fisher", "sidak", "count", "lancaster"), 
                      several.ok = FALSE)
  if (!is.na(plot.chr)) {
    if (!is.numeric(plot.chr)) {
      stop("plot.chr must be either NA or a numeric value.")
    }
    if (!(plot.chr %in% unique(results(hicexp)$chr))) {
      stop("The chr chosen as a subset must exist in the data object")
    }
  }
  # check that data has been compared
  if (nrow(results(hicexp)) < 1) {
    stop("Differences must be detected before making a manhattan plot.")
  }
  
  if (pval_aggregate == "standard") {
    # make data.frame for plotting
    man.df <- data.frame(BP = c(results(hicexp)$region1, 
                                results(hicexp)$region2),
                         CHR = as.numeric(c(results(hicexp)$chr, 
                                            results(hicexp)$chr)), 
                         P = c(results(hicexp)$p.adj, 
                               results(hicexp)$p.adj),
                         SNP = paste0(results(hicexp)$chr, ":", results(hicexp)$region1, "-", results(hicexp)$region2))
    # subset by chr is option is not NA
    if (!is.na(plot.chr)) {
      man.df <- man.df[man.df$CHR == plot.chr,]
    }
    # plot
    suppressWarnings(qqman::manhattan(man.df, suggestiveline = FALSE, genomewideline = FALSE))
  }
  
  if (pval_aggregate == "fisher") {
    # make aggregate p-value for regions
    regions <- c(paste0(results(hicexp)$chr, ':', results(hicexp)$region1),
                 paste0(results(hicexp)$chr, ':', results(hicexp)$region2))
    p.values <- c(results(hicexp)$p.adj, results(hicexp)$p.adj)
    
    ## Fisher method
    # fisher_aggregate <- aggregate(p.values, by = list(regions), 
    #                               FUN = function(p) {
    #   combined <- -2 * sum(log(p))
    #   c.pval <- pchisq(combined, df = 2 * length(p))
    #   return(c.pval)
    # })
    
    fisher_aggregate <- aggregate(p.values, 
                                  by = list(regions), 
                                  FUN = function(x) {
                                    if (length(x) > 1) {
                                      aggregation::fisher(x)
                                    } else {
                                      x
                                    }
                                    })
    
    fisher_aggregate <- cbind(read.table(text = fisher_aggregate$Group.1, 
                                         sep = ":"), fisher_aggregate$x)
    colnames(fisher_aggregate) <- c("CHR", "BP", "P")
    fisher_aggregate$P[fisher_aggregate$P == 0] <- 10^-100
    # Add SNP column
    fisher_aggregate$SNP <- paste0(fisher_aggregate$CHR, ":", fisher_aggregate$BP)
    
    # subset by chr is option is not NA
    if (!is.na(plot.chr)) {
      fisher_aggregate <- fisher_aggregate[fisher_aggregate$CHR == plot.chr,]
    }
    # plot combined p-value manahttan plots
    suppressWarnings(qqman::manhattan(fisher_aggregate, suggestiveline = FALSE, genomewideline = FALSE))
    
    man.df <- fisher_aggregate
  }
  
  if (pval_aggregate == "sidak") {
    # make aggregate p-value for regions
    regions <- c(paste0(results(hicexp)$chr, ':', results(hicexp)$region1),
                 paste0(results(hicexp)$chr, ':', results(hicexp)$region2))
    p.values <- c(results(hicexp)$p.adj, results(hicexp)$p.adj)
    p.values[p.values == 1] <- 0.99999 # change pvalues from 1 so sumz works correctly
    
    
    sidak_aggregate <- aggregate(p.values, 
                                           by = list(regions), 
                                           FUN = function(x) {
                                             if (length(x) > 1) {
                                               aggregation::sidak(x) 
                                             } else {
                                               x
                                             }
                                            })
    
    sidak_aggregate <- cbind(read.table(text = sidak_aggregate$Group.1,
                                                  sep = ":"), sidak_aggregate$x)
    colnames(sidak_aggregate) <- c("CHR", "BP", "P")
    # make sure there are no zero p-values
    sidak_aggregate$P[sidak_aggregate$P == 0] <- .Machine$double.xmin
    # Add SNP column
    sidak_aggregate$SNP <- paste0(sidak_aggregate$CHR, ":", sidak_aggregate$BP)
    
    # subset by chr is option is not NA
    if (!is.na(plot.chr)) {
      sidak_aggregate <- sidak_aggregate[sidak_aggregate$CHR == plot.chr,]
    }
    
    suppressWarnings(qqman::manhattan(sidak_aggregate, suggestiveline = FALSE, genomewideline = FALSE))
    
    man.df <- sidak_aggregate
  }
  
  
  if (pval_aggregate == 'count') {
    # make aggregate count for regions
    regions <- c(paste0(results(hicexp)$chr, ':', results(hicexp)$region1),
                 paste0(results(hicexp)$chr, ':', results(hicexp)$region2))
    p.values <- c(results(hicexp)$p.adj, results(hicexp)$p.adj)
    count <- ifelse(p.values < p.adj_cutoff, 1, 0)
    
    ## count method
    count_aggregate <- aggregate(count, by = list(regions), 
                                 FUN = function(cnt) {
      c.sum <- sum(cnt)
      # c.pval <- 1 / sqrt(c.sum)
      return(c.sum)
    })
    
    # count_aggregate$x[is.infinite(count_aggregate$x)] <- 1 # replace any regions that had counts of 0 significant with pseudo-pval of 1
    count_aggregate <- cbind(read.table(text = count_aggregate$Group.1, sep = ":"),
                             count_aggregate$x)
    colnames(count_aggregate) <- c("CHR", "BP", "P")
    # Add SNP column
    count_aggregate$SNP <- paste0(count_aggregate$CHR, ":", count_aggregate$BP)
    
    # subset by chr is option is not NA
    if (!is.na(plot.chr)) {
      count_aggregate <- count_aggregate[count_aggregate$CHR == plot.chr,]
    }
    # plot combined p-value manahttan plots
    suppressWarnings(.count_manhattan(count_aggregate, ylab = "Number of times significant"))
    
    man.df <- count_aggregate
    colnames(man.df)[3] <- 'count'
  }
  
  # lancaster method
  if (pval_aggregate == "lancaster") {
    # make aggregate p-value for regions
    regions <- c(paste0(results(hicexp)$chr, ':', results(hicexp)$region1),
                 paste0(results(hicexp)$chr, ':', results(hicexp)$region2))
    p.values <- c(results(hicexp)$p.adj, results(hicexp)$p.adj)
    
    
    clt_aggregate <- aggregate(p.values, 
                                  by = list(regions), 
                                  FUN = function(x) {
                                    if (length(x) > 1) {
                                      aggregation::lancaster(x)
                                    } else {
                                      x
                                    }
                                  })
    
    clt_aggregate <- cbind(read.table(text = clt_aggregate$Group.1, 
                                         sep = ":"), clt_aggregate$x)
    colnames(clt_aggregate) <- c("CHR", "BP", "P")
    # clt_aggregate$P[clt_aggregate$P == 0] <- 10^-100
    # Add SNP column
    clt_aggregate$SNP <- paste0(clt_aggregate$CHR, ":", clt_aggregate$BP)
    
    # subset by chr is option is not NA
    if (!is.na(plot.chr)) {
      clt_aggregate <- clt_aggregate[clt_aggregate$CHR == plot.chr,]
    }
    # plot combined p-value manahttan plots
    suppressWarnings(qqman::manhattan(clt_aggregate, suggestiveline = FALSE, genomewideline = FALSE))
    
    man.df <- clt_aggregate
  }
  
  
  # return man.df if requested
  if (return_df) {
    return(man.df)
  } 
}



#' Plot the p-value results from topDirs
#' 
#' @export
#' @param dirs The output of the topDirs function when the return_df 
#'     option is set to "bed". 
#' @param plot.chr A numeric value indicating a specific
#'     chromosome number to subset the plot to. Defaults
#'     to NA indicating that all chromosomes will be plotted.
#' @return A plot.
#' @examples 
#' data('hicexp_diff')
#' dirs <- topDirs(hicexp_diff, return_df = 'bed')
#' plot_pvals(dirs)

plot_pvals <- function(dirs, plot.chr = NA) {
  # check input
  if (ncol(dirs) != 8) {
    stop("Use only the output of topDirs() where return_df = 'bed' for this function")
  }
  if (!is.na(plot.chr)) {
    if (!is.numeric(plot.chr)) {
      stop("plot.chr must be either NA or a numeric value.")
    }
    if (!(paste0('chr', plot.chr) %in% unique(dirs$chr))) {
      stop("The chr chosen as a subset must exist in the data object")
    }
  }
  # make dataframe for plotting
  df <- data.frame(CHR = as.numeric(sub('chr', '', dirs$chr)), BP = dirs$start, P = as.numeric(dirs$avgP.adj), 
                   SNP = paste0(dirs$chr, ":", dirs$start, "-", dirs$end))
  # subset if plot.chr is not NA
  if(!is.na(plot.chr[1])) {
    df <- df[df$CHR == plot.chr,]
  }
  # plot combined p-value manahttan plots
  suppressWarnings(qqman::manhattan(df, suggestiveline = FALSE, genomewideline = FALSE))
}


#' Plot the count results from topDirs
#' 
#' @export
#' @param dirs The output of the topDirs function when the return_df 
#'     option is set to "bed". 
#' @param plot.chr A numeric value indicating a specific
#'     chromosome number to subset the plot to. Defaults
#'     to NA indicating that all chromosomes will be plotted.
#' @return A plot.
#' @examples 
#' data('hicexp_diff')
#' dirs <- topDirs(hicexp_diff, return_df = 'bed')
#' plot_counts(dirs)

plot_counts <- function(dirs, plot.chr = NA) {
  # check input
  if (ncol(dirs) != 8) {
    stop("Use only the output of topDirs() where return_df = 'bed' for this function")
  }
  if (!is.na(plot.chr)) {
    if (!is.numeric(plot.chr)) {
      stop("plot.chr must be either NA or a numeric value.")
    }
    if (!(paste0('chr', plot.chr) %in% unique(dirs$chr))) {
      stop("The chr chosen as a subset must exist in the data object")
    }
  }
  # make dataframe for plotting
  df <- data.frame(CHR = as.numeric(sub('chr', '', dirs$chr)), BP = dirs$start, P = dirs$count,
                   SNP = paste0(dirs$chr, ":", dirs$start, "-", dirs$end))
  # subset if plot.chr is not NA
  if(!is.na(plot.chr[1])) {
    df <- df[df$CHR == plot.chr,]
  }
  # plot
  suppressWarnings(.count_manhattan(df, ylab = "Number of times significant"))
}




# modified manhattan plot function for counts
.count_manhattan <- function (x, chr = "CHR", bp = "BP", p = "P", snp = "SNP", col = c("gray10", 
                                                                                       "gray60"), chrlabs = NULL, suggestiveline = FALSE, 
                              genomewideline = FALSE, highlight = NULL, 
                              annotatePval = NULL, annotateTop = TRUE, ...) 
{
  CHR = BP = P = index = NULL
  if (!(chr %in% names(x))) 
    stop(paste("Column", chr, "not found!"))
  if (!(bp %in% names(x))) 
    stop(paste("Column", bp, "not found!"))
  if (!(p %in% names(x))) 
    stop(paste("Column", p, "not found!"))
  if (!(snp %in% names(x))) 
    warning(paste("No SNP column found. OK unless you're trying to highlight."))
  if (!is.numeric(x[[chr]])) 
    stop(paste(chr, "column should be numeric. Do you have 'X', 'Y', 'MT', etc? If so change to numbers and try again."))
  if (!is.numeric(x[[bp]])) 
    stop(paste(bp, "column should be numeric."))
  if (!is.numeric(x[[p]])) 
    stop(paste(p, "column should be numeric."))
  d = data.frame(CHR = x[[chr]], BP = x[[bp]], P = x[[p]])
  if (!is.null(x[[snp]])) 
    d = transform(d, SNP = x[[snp]])
  d <- subset(d, (is.numeric(CHR) & is.numeric(BP) & is.numeric(P)))
  d <- d[order(d$CHR, d$BP), ]
  d$logp <- d$P
  
  d$pos = NA
  d$index = NA
  ind = 0
  for (i in unique(d$CHR)) {
    ind = ind + 1
    d[d$CHR == i, ]$index = ind
  }
  nchr = length(unique(d$CHR))
  if (nchr == 1) {
    d$pos = d$BP
    ticks = floor(length(d$pos))/2 + 1
    xlabel = paste("Chromosome", unique(d$CHR), "position")
    labs = ticks
  }
  else {
    lastbase = 0
    ticks = NULL
    for (i in unique(d$index)) {
      if (i == 1) {
        d[d$index == i, ]$pos = d[d$index == i, ]$BP
      }
      else {
        lastbase = lastbase + tail(subset(d, index == 
                                            i - 1)$BP, 1)
        d[d$index == i, ]$pos = d[d$index == i, ]$BP + 
          lastbase
      }
      ticks = c(ticks, (min(d[d$index == i, ]$pos) + max(d[d$index == 
                                                             i, ]$pos))/2 + 1)
    }
    xlabel = "Chromosome"
    labs <- unique(d$CHR)
  }
  xmax = ceiling(max(d$pos) * 1.03)
  xmin = floor(max(d$pos) * -0.03)
  def_args <- list(xaxt = "n", bty = "n", xaxs = "i", yaxs = "i", 
                   las = 1, pch = 20, xlim = c(xmin, xmax), ylim = c(0, 
                                                                     ceiling(max(d$logp))+1), xlab = xlabel)
  dotargs <- list(...)
  do.call("plot", c(NA, dotargs, def_args[!names(def_args) %in% 
                                            names(dotargs)]))
  if (!is.null(chrlabs)) {
    if (is.character(chrlabs)) {
      if (length(chrlabs) == length(labs)) {
        labs <- chrlabs
      }
      else {
        warning("You're trying to specify chromosome labels but the number of labels != number of chromosomes.")
      }
    }
    else {
      warning("If you're trying to specify chromosome labels, chrlabs must be a character vector")
    }
  }
  if (nchr == 1) {
    axis(1, ...)
  }
  else {
    axis(1, at = ticks, labels = labs, ...)
  }
  col = rep(col, max(d$CHR))
  if (nchr == 1) {
    with(d, points(pos, logp, pch = 20, col = col[1], ...))
  }
  else {
    icol = 1
    for (i in unique(d$index)) {
      with(d[d$index == unique(d$index)[i], ], points(pos, 
                                                      logp, col = col[icol], pch = 20, ...))
      icol = icol + 1
    }
  }
  # if (suggestiveline) 
  #   abline(h = suggestiveline, col = "blue")
  # if (genomewideline) 
  #   abline(h = genomewideline, col = "red")
  if (!is.null(highlight)) {
    if (any(!(highlight %in% d$SNP))) 
      warning("You're trying to highlight SNPs that don't exist in your results.")
    d.highlight = d[which(d$SNP %in% highlight), ]
    with(d.highlight, points(pos, logp, col = "green3", pch = 20, 
                             ...))
  }
  if (!is.null(annotatePval)) {
    topHits = subset(d, P <= annotatePval)
    par(xpd = TRUE)
    if (annotateTop == FALSE) {
      with(subset(d, P <= annotatePval), textxy(pos, -log10(P), 
                                                offset = 0.625, labs = topHits$SNP, cex = 0.45), 
           ...)
    }
    else {
      topHits <- topHits[order(topHits$P), ]
      topSNPs <- NULL
      for (i in unique(topHits$CHR)) {
        chrSNPs <- topHits[topHits$CHR == i, ]
        topSNPs <- rbind(topSNPs, chrSNPs[1, ])
      }
      textxy(topSNPs$pos, -log10(topSNPs$P), offset = 0.625, 
             labs = topSNPs$SNP, cex = 0.5, ...)
    }
  }
  par(xpd = FALSE)
}

#' A 4 column sparse matrix for a Hi-C matrix.
#'
#' A matrix object with 4 columns and 54307 rows. 
#'     Sample 4 of 7 included as example Hi-C data.
#'     This is replicate 4 of HCT-116 cell
#'     line at 100KB resolution from chHCT116_r22.
#'
#' @source Data from Rao 2017. See their website at
#'     \url{http://www.aidenlab.org/}
#'      Or the the GEO link to download the data
#'     \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE104888}
#'
#' @return A matrix
"HCT116_r4"

#' hicexp object with 4 samples from two groups.  
#'
#' A hicexp object with a hic_table slot containing 666 rows
#'     from chromosome 22 at 1MB resolution.
#'
#' @source Data from Rao 2017. See their website at
#'     \url{http://www.aidenlab.org/}
#'      Or the the GEO link to download the data
#'     \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE104888}
#'
#' @return A hicexp object
#' 
"hicexp2"

#' Make MD plots for all combinations of a condition
#' 
#' @importFrom graphics abline legend lines par persp
#'     points smoothScatter axis
#' @param hicexp A hicexp object.
#' @param prow The number of rows to use for the 
#'    grid of MD plots. Defaults to 3.
#' @param pcol The number of columns to use for
#'     the grid of MD plots. Defaults to 3.
#' @param plot.chr A specific chromosome or 
#'     set of chromosome which you want to plot.
#'     This should be a numeric value, i.e. to
#'     plot chromosome 1 set plot.chr = 1, to
#'     plot chromosomes 1 and 5 set plot.chr 
#'     = c(1, 5). Defaults to NA indicating that
#'     all chromosomes present in the hicexp
#'     will be plotted. 
#' @param plot.loess Logical, should a loess curve
#'     be plotted over the MD plots. Note setting
#'     this to TRUE will increase the computational
#'     time for plotting.
#'
#' @return A set of MD plots.
#' 
#'
#' @export
#' @examples
#' data("hicexp2")
#' MD_hicexp(hicexp2)




MD_hicexp <- function(hicexp, prow = 3, pcol = 3, plot.chr = NA, plot.loess = FALSE) {
  # check if more than one chromosome then split
  if (length(unique(hic_table(hicexp)$chr)) > 1) {
    chr_table <- split(hic_table(hicexp), hic_table(hicexp)$chr)
    # check if chr to plot is specified
    if (!is.na(plot.chr[1])) {
      chrs.to.plot <- which(as.numeric(names(chr_table)) %in% plot.chr)
      if (length(chrs.to.plot) < 1) {
        stop("Chr selected in plot.chr does not exist in the data")
      }
      tmp <- lapply(chr_table[chrs.to.plot], .MD.hicexp.chr, prow = prow, 
                    pcol = pcol, plot.loess = plot.loess)
    } else {
      # otherwise plot every chr
      tmp <- lapply(chr_table, .MD.hicexp.chr, prow = prow, pcol = pcol, plot.loess = plot.loess)
    }
  } else {
    # if only a single chr just plot
    .MD.hicexp.chr(hic_table(hicexp), prow = prow, pcol = pcol, plot.loess = plot.loess)
  }
  
}



.MD.hicexp.chr <- function(chr_table, prow, pcol, plot.loess) {
  # save par
  old_par <- par()
  # get all unique pairs
  samples <- 5:ncol(chr_table)
  combinations <- combn(samples, 2)
  # make M matrix
  M_matrix <- matrix(nrow = nrow(chr_table), ncol = ncol(combinations))
  plot_list <- list()
  par(mfrow = c(prow, pcol), mai = c(0.3, 0.3, 0.2, 0.1))
  for (j in 1:ncol(combinations)) {
    M_matrix[,j] <- log2( (chr_table[, combinations[1,j], with = FALSE] + 1)[[1]] / 
                            (chr_table[, combinations[2,j], with = FALSE] + 1)[[1]] )
    # make MD plot
    .MD.smooth(M_matrix[,j], chr_table$D, title = paste0('chr', chr_table$chr[1], 
                                                         ' ', 
                                                         'Sample ', 
                                                         combinations[1,j] - 4,
                                                         ' vs. ', combinations[2,j] - 4),
                                                          ylab = '', xlab = '',
                                                          plot.loess = plot.loess)
  }
  # reset par
  suppressWarnings(par(old_par))
}


#' Plot a composite MD plot with the results of a comparison
#' @param hicexp A hicexp object which has 
#'     had a multiHiCcompare comparison step performed on it.
#' @param plot.chr A specific chromosome or 
#'     set of chromosome which you want to plot.
#'     This should be a numeric value, i.e. to
#'     plot chromosome 1 set plot.chr = 1, to
#'     plot chromosomes 1 and 5 set plot.chr 
#'     = c(1, 5). Defaults to NA indicating that
#'     all chromosomes present in the hicexp
#'     will be plotted. 
#' @param D.range Allows for subsetting of the plot by
#'     Distance. Set to proportion of total distance 
#'     that you want to be displayed. Value of 1 
#'     indicates that the entire distance range 
#'     will be displayed. Defaults to 1.
#' @return An MD plot
#' @examples 
#' data("hicexp_diff")
#' MD_composite(hicexp_diff)
#' @export


MD_composite <- function(hicexp, plot.chr = NA, D.range = 1) {
  # check to make sure data has been compared
  if (nrow(results(hicexp)) < 1) {
    stop("You must compare the Hi-C data first before using 
         this plot function")
  }
  
  # check D.range
  if (D.range > 1 | D.range <= 0) {
    stop('D.range must be less than or equal to 1 and greater than 0.')
  }
  
  # check if more than one chromosome then split
  if (length(unique(results(hicexp)$chr)) > 1) {
    chr_table <- split(results(hicexp), results(hicexp)$chr)
    # check if chr to plot is specified
    if (!is.na(plot.chr[1])) {
      chrs.to.plot <- which(as.numeric(names(chr_table)) %in% plot.chr)
      if (length(chrs.to.plot) < 1) {
        stop("Chr selected in plot.chr does not exist in the data")
      }
      tmp <- lapply(chr_table[chrs.to.plot], function(x) {
        .MD.smooth(x$logFC, x$D, x$p.adj, title = paste0('chr', x$chr[1]),
                   plot.loess = FALSE, D.range = D.range)
      })
    } else {
      # otherwise plot every chr
      tmp <- lapply(chr_table, function(x) {
        .MD.smooth(x$logFC, x$D, x$p.adj, title = paste0('chr', x$chr[1]),
                   plot.loess = FALSE, D.range = D.range)
      })
    }
  } else {
    # if only a single chr just plot
    .MD.smooth(M = results(hicexp)$logFC, D = results(hicexp)$D, 
               p.val = results(hicexp)$p.adj, 
               title = "Composite MD Plot",
               plot.loess = FALSE, D.range = D.range)
  }
}


.MD.smooth <- function(M, D, p.val = NA, title = 'MD Plot', ylab = 'M', 
                       xlab = 'Distance', plot.loess = FALSE, D.range = 1) {
  # subset plot by D
  if (D.range < 1) {
    max.D <- max(D)
    cut.point <- ceiling(D.range * max.D)
    # subset M, D, p.val vectors based on cut.point
    keep <- D <= cut.point
    D <- D[keep]
    M <- M[keep]
    p.val <- p.val[keep]
  }
  
  
  # smooth scatter version
  smoothScatter(D, M, xlab = xlab, ylab = ylab, main = title, cex.main = 0.85)
  abline(h = 0)
  if (!is.na(p.val[1])) {
    p0.001 <- which(p.val < 0.001)
    p0.05 <- which(p.val >= 0.001 & p.val < 0.05)
    points(D[p0.001], M[p0.001], col = "red", pch = 20)
    points(D[p0.05], M[p0.05], col = 'yellow', pch = 20)
    legend('bottomright', legend = c('P < 0.001', 'P < 0.05'), 
           fill = c('red', 'yellow'), bty = 'n', horiz = TRUE)
  }
  # add loess fit to plot
  if (plot.loess) {
    lines(loess.smooth(D, M, span = 1/2, degree = 1), col = 'red')
  }
  
}





#' Function to visualize p-values from multiHiCcompare results
#' 
#' @param hicexp A hicexp object that has been
#'     normalized and has had differences detected.
#' @param alpha The alpha level at which you will 
#'     call a p-value significant. If this is set to
#'     a numeric value then any p-values >= alpha will
#'     be set to 1 for the visualization in the heatmap.
#'     Defaults to NA for visualization of all p-values.
#' @param chr The numeric value for the chromosome that 
#'     you want to plot. Set to 0 to plot all chromosomes
#'     in the dataset.
#' @details The goal of this function is to visualize
#'     where in the Hi-C matrix the differences are
#'     occuring between two experimental conditions.
#'     The function will produce a heatmap of the
#'     -log10(p-values) * sign(logFC) 
#'     to visualize where the
#'     significant differences between the datasets
#'     are occuring on the genome. 
#' @return A heatmap
#' @examples 
#' data("hicexp_diff")
#' pval_heatmap(hicexp_diff, chr = 22)
#' @importFrom pheatmap pheatmap
#' @export

pval_heatmap <- function(hicexp, alpha = NA, chr = 0) {
  # check input
  if (nrow(results(hicexp)) < 1) {
    stop("You must compare the hicexp first.")
  }
  if (!is.numeric(chr)) {
    stop("chr should be a numeric value")
  }
  if (chr != 0 & sum(chr == as.numeric(unique(results(hicexp)$chr))) < 1) {
    stop("The value of chr selected does not appear in the hicexp")
  }
  
  # if chr = 0 split data up by chr
  if (chr == 0) {
    chr.list <- split(results(hicexp), results(hicexp)$chr)
  } else {
    # otherwise subset data to just the selected chr
    chr.list <- list(subset(results(hicexp)[chr == chr,]))
  }
  
  # convert to sparse matrix
  m <- lapply(chr.list, function(x) {
    new.table <- cbind(x$region1, x$region2, x$p.adj)
    return(new.table)
  })
  
  # convert to full matrix
  m <- lapply(m, HiCcompare::sparse2full) 
  
  # get fold change
  fc<- lapply(chr.list, function(x) {
    new.table <- cbind(x$region1, x$region2, x$logFC)
    return(new.table)
  })
  fc <- lapply(fc, HiCcompare::sparse2full)
  # remove non significant values from matrix if alpha is set to a value
  if (!is.na(alpha)) {
    for (i in seq_len(length(m))) {
      m[[i]][m[[i]] >= alpha] <- 1
    }
  }
  # plot heatmap
  mapply(function(m, fc) {
    pheatmap::pheatmap(-log10(m) * sign(fc), cluster_rows = FALSE, 
                       cluster_cols = FALSE, show_rownames = FALSE, 
                       show_colnames = FALSE)
    }, 
    m, fc, SIMPLIFY = FALSE)
}

#' A GenomicRanges object containing centromeric, gvar, and stalk regions.
#'
#' A GRanges object with 2 metadata columns and 70 rows. 
#'     These ranges indicate the locations of centromeres,
#'     stalks, and gvar regions from hg38.
#'     Use this for filtering out these regions from 
#'     your data.
#' @source Data from UCSC
#'     \url{http://hgdownload.cse.ucsc.edu/goldenPath/hg38/database/cytoBand.txt.gz}

#'
#' @return A GRanges object
"hg38_cyto"

#' Function to apply either biocParallel or standard lapply
#' 
#' @importFrom pbapply pblapply
#' @param parallel Logical, should parallel processing be used?
#' @param x The main list object which the function will be applied to.
#' @param FUN The function to be applied.
#' @param ... Additional arguments for bplapply or lapply.
#' @return results of lapply or bplapply


smartApply <- function(parallel, x, FUN, ...) {
  if (parallel) {
    BiocParallel::bplapply(x, FUN = FUN, ... = ...)
  } else {
    # lapply(x, FUN = FUN, ... = ...)
    pbapply::pblapply(x, FUN = FUN, ... = ...)
  }
}

#' Make Hi-C experiment object from data
#' 
#' @export
#' @importFrom dplyr full_join left_join right_join
#' @import data.table
#' 
#' @param ... Hi-C data. Data must in sparse upper triangular 
#'     format with 4 columns: chr, region1, region2, IF or
#'     in 7 column BEDPE format with columns chr, start1, 
#'     end1, chr, start2, end2, IF.
#' @param data_list Alternate way to enter data. If you have
#'     your Hi-C data in the form of a list already with each
#'     entry of the list representing a sample use this option.
#' @param groups A vector of the experimental groups 
#'     corresponding to each Hi-C data object entered.
#'     If it is not in factor form when entered it will
#'     be converted to a factor.
#' @param covariates Optional data.frame containing 
#'     covariate information for your Hi-C experiment.
#'     Some examples are enzyme used, batch number, etc.
#'     Should have the same number of rows as the number
#'     of Hi-C data objects entered and columns corresponding
#'     to covariates. 
#' @param remove_zeros Logical, should rows with 1 or more
#'     zero IF values be removed?
#' @param zero.p The proportion of zeros in a row to filter by. 
#'     If the proportion of zeros in a row is <= zero.p
#'     the row will be filtered out, i.e. zero.p = 1 means
#'     nothing is filtered based on zeros and zero.p = 0 
#'     will filter rows that have any zeros.
#' @param A.min The minimum average expression value
#'     (row mean) for an interaction pair. If the 
#'     interaction pair has an average expression 
#'     value less than A.min the row will be filtered
#'     out.
#' @param filter Logical, should filtering be performed?
#'     Defaults to TRUE. If TRUE it will filter out
#'     the interactions that have low average IFs
#'     or large numbers of 0 IF values. As these
#'     interactions are not very interesting and
#'     are commonly false positives during difference
#'     detection it is better to remove them from
#'     the dataset. Additionally, filtering will
#'     help speed up the run time of multiHiCcompare. 
#'     Filtering can be performed before or after 
#'     normalization, however the best computational
#'     speed gain will occur when filtering is done
#'     before normalization. Filtering parameters
#'     are controlled by the zero.p and A.min options.
#' @param remove.regions A GenomicRanges object indicating
#'     specific regions to be filtered out. By default
#'     this is the hg19 centromeric, gvar, and stalk
#'     regions. Also included in the package is
#'     hg38_cyto. If your data is not hg19 you will 
#'     need to substitute this file. To choose not 
#'     to filter any regions set regions = NULL. NOTE:
#'     if you set filter = FALSE these regions will NOT
#'     be removed. This occurs in conjuction with the 
#'     filtering step.
#' @details Use this function to create a hicexp object for
#'     analysis in multiHiCcompare. Filtering can also be 
#'     performed in this step if the filter option is 
#'     set to TRUE. Filtering parameters are controlled
#'     by the zero.p and A.min options.
#'     
#' @return A hicexp object.
#' @examples 
#' # load data in sparse upper triangular format
#' data("HCT116_r1", "HCT116_r2", "HCT116_r3", "HCT116_r4", 
#'     "HCT116_r5", "HCT116_r6")
#' # make groups & covariate input
#' groups <- factor(c(1, 1, 1, 2, 2, 2))
#' covariates <- data.frame(enzyme = factor(c('mobi', 'mboi', 'mboi',
#'  'dpnii', 'dpnii', 'dpnii')), batch = c(1, 2, 1, 2, 1, 2))
#' # make the hicexp object
#' hicexp <- make_hicexp(HCT116_r1, HCT116_r2, HCT116_r3, HCT116_r4,
#'      HCT116_r5, HCT116_r6, groups = groups, 
#'      covariates = covariates)


make_hicexp <- function(..., data_list = NA, groups, covariates = NULL, 
                        remove_zeros = FALSE,
                        zero.p = 0.8, A.min = 5, filter = TRUE, remove.regions = hg19_cyto) {
  if (!is.na(data_list[1])) {
    tabs <- data_list
  } else {
    tabs <- list(...)
  }
  # check number of columns of input data
  if(ncol(tabs[[1]]) != 4 &  ncol(tabs[[1]]) != 7) {
    stop("You must enter data in 4 column sparse matrix format
         or in 7 column BEDPE format.")
  }
  # if BEDPE pull out only columns we need
  if (ncol(tabs[[1]]) == 7) {
    tabs <- lapply(tabs, function(x) {
      colnames(x) <- c('chr1', 'start1', 'end1', 'chr2', 'start2', 'end2', 'IF')
      new.x <- x[, c('chr1', 'start1', 'start2', 'IF')]
      return(new.x)
    })
  }
  # set column names of data 
  tabs <- lapply(tabs, function(x) {
    colnames(x) <- c('chr', 'region1', 'region2', 'IF') 
    return(x)
  })
  
  # initialize values
  # hic_table <- list() # initialize list for tables for each condition
  num_per_group <- table(groups)
  uniq_groups <- unique(groups)
  res <- vector(length = length(uniq_groups))
  
  # convert groups to a factor if it is not already
  if (!is.factor(groups)) {
    groups <- as.factor(groups)
  }
  
  # check for correct input
  if (length(groups) != length(tabs)) {
    stop("Length of groups must equal the number of Hi-C data objects entered")
  }
  if (sum(num_per_group < 2) > 0) {
    warning("Each experimental condition should have at least 2 samples. 
            If you have less than 2 samples per group use HiCcompare instead")
  }
  if (!is.null(covariates)) {
    # check for data.frame
    if (!is(covariates, "data.frame")) {
      stop("Enter a data.frame for covariates")
    }
    if (nrow(covariates) != length(tabs)) {
      stop("Number of rows in covariates should correspond to number 
           of Hi-C data objects entered")
    }
    }
  if (zero.p < 0 | zero.p > 1) {
    stop("zero.p must be in [0,1]")
  }
  if (A.min < 0) {
    stop("A.min must be >= 0")
  }
  
  # cycle through groups to create a table for each experimental condition
  
  tmp_table <- dplyr::full_join(tabs[[1]], tabs[[2]], 
                                by = c('chr' = 'chr', 'region1' = 'region1',
                                       'region2' = 'region2'))
  if (length(tabs) > 2) {
    for(j in 3:length(tabs)) {
      tmp_table <- dplyr::full_join(tmp_table, tabs[[j]], 
                                    by = c('chr' = 'chr', 
                                           'region1' = 'region1',
                                           'region2' = 'region2'))
    }
  }
  # rename table columns & replace NA IFs with 0
  colnames(tmp_table)[4:ncol(tmp_table)] <- paste0("IF", 1:(ncol(tmp_table) - 3))
  tmp_table[is.na(tmp_table)] <- 0
  
  
  # calculate resolution
  bins <- unique(c(tmp_table$region1, tmp_table$region2))
  bins <- bins[order(bins)]
  resolution <- min(diff(bins))
  tmp_table <- data.table::as.data.table(tmp_table)
  tmp_table[, `:=`(D, abs(region2 - region1) / resolution)]
  # rearrange columns
  tmp_table <- tmp_table[, c('chr', 'region1', 'region2', 'D',
                             paste0("IF", 1:(ncol(tmp_table) - 4))), with = FALSE]
  
  # set table in place on condition list
  hic_table <- tmp_table
  # check chr format, if "chr#" change to just the number
  if (!is.numeric(hic_table$chr)) {
    # replace any "chr"
    hic_table[, chr := sub("chr", "", chr)]
    # replace any X 
    hic_table[, chr := sub("X", "23", chr)]
    # replace any Y
    hic_table[, chr := sub("Y", "24", chr)]
    # convert to numeric
    hic_table[, chr := as.numeric(chr)]
  }
  # sort hic_table
  hic_table <- hic_table[order(chr, region1, region2),]
  
  # check that all resolutions are equal
  if (length(unique(res)) > 1) {
    stop("Resolution of all datasets must be equal.")
  }
  # remove rows with 0's
  if (remove_zeros) {
    IFs <- as.matrix(hic_table[, -c("chr", "region1", "region2", "D"), with = FALSE])
    IFs <- IFs == 0 # matrix of TRUE where zeros occur
    keep <- rowSums(IFs) == 0 # if row has no zeros it will sum to 0
    hic_table <- hic_table[keep,]
  }
  
  
  # make metadata 
  metadata <- data.frame(group = groups)
  row.names(metadata) <- paste0("Sample", 1:length(groups))
  if (!is.null(covariates)) {
    metadata <- cbind(metadata, covariates)
  }
  
  # put into hicexp object
  experiment <- new("Hicexp", hic_table = hic_table, 
                    comparison = data.table::data.table(), 
                    metadata = metadata, resolution = resolution, 
                    normalized = FALSE)
  
  # filter
  if (filter) {
    experiment <- hic_filter(experiment, zero.p = zero.p, A.min = A.min, remove.regions = remove.regions)
  }
  
  return(experiment)
  }

test_that('make_hicexp works', {
  data("HCT116_r1", "HCT116_r2", "HCT116_r3", "HCT116_r4", "HCT116_r5","HCT116_r6")
  groups <- c(1, 1, 1, 2, 2, 2)
  covariates <- data.frame(enzyme = c('mobi', 'mboi', 'mboi', 'dpnii',
                                      'dpnii', 'dpnii'), 
                           batch = c(1, 2, 1, 2, 1, 2))
  hicexp_new <- make_hicexp(HCT116_r1, HCT116_r2, HCT116_r3, HCT116_r4, HCT116_r5, HCT116_r6, 
                            groups = groups, covariates = covariates)
  expect_is(hicexp_new, "Hicexp")
  
  # test for errors on wrong input
  expect_error(make_hicexp(HCT116_r2, HCT116_r3, HCT116_r4, HCT116_r5, HCT116_r6, 
                           groups = groups, covariates = covariates),
               "Length of groups must equal the number of Hi-C data objects entered")
  expect_error(make_hicexp(HCT116_r1, HCT116_r2, HCT116_r3, HCT116_r4, HCT116_r5, HCT116_r6, 
                           groups = c(1,1,1,2,2), 
                           covariates = covariates), 
               "Length of groups must equal the number of Hi-C data objects entered")
  
  # providing list or data give same results
  dat <- list(HCT116_r1, HCT116_r2, HCT116_r3, HCT116_r4)
  hicexp1 <- make_hicexp(HCT116_r1, HCT116_r2, HCT116_r3, HCT116_r4, 
                         groups = c(1,1,2,2))
  hicexp2 <- make_hicexp(data_list = dat, groups = c(1,1,2,2))
  expect_equal(hicexp1, hicexp2)
})

#' An S4 class for working with Hi-C data 
#' 
#' @slot hic_table A data.table containing the sparse upper triangular matrix 
#'     for your Hi-C data.
#' @slot comparison The results of a multiHiCcompare comparison.
#' @slot metadata Data.frame for covariate information.
#' @slot resolution The resolution of the dataset.
#' @slot normalized Indicator for if data has been normalized.
#' @exportClass Hicexp
#' @import methods
#' @return Hicexp class 
#' @examples 
#' data('hicexp2')
#' hicexp2

setClass("Hicexp",
         representation(
           hic_table = "data.table",
           comparison = "data.table",
           metadata= "data.frame",
           resolution = "numeric",
           normalized = "logical")
         # prototype =  prototype(hic_tables= NULL, metadata=NULL)
)

#' Print information about a HiCexp object
#' @rdname show
#' @aliases show,character,ANY-method
#' @exportMethod show
#' @param object A Hicexp object
#' @return HiCexp information
setMethod("show", "Hicexp", function(object) {
  # get unique groups
  uniq_groups <- length(unique(object@metadata$group))
  # get number samples per groups
  s_per_groups <- table(object@metadata$group)
  cat("Hi-C Experiment Object \n")
  cat(paste0(uniq_groups, " experimental groups \n"))
  for (i in 1:length(s_per_groups)) {
    cat(paste0("Group ", i, ' has ', s_per_groups[i], ' samples \n'))
  }
  if (object@normalized) {
    cat("Data has been normalized")
  }
})

# set generics

#' @docType methods
#' @rdname hic_table
setGeneric("hic_table", function(x) {
  standardGeneric("hic_table")
})

#' @docType methods
#' @rdname results
setGeneric("results", function(x) {
  standardGeneric("results")
})

#' @docType methods
#' @rdname meta
setGeneric("meta", function(x) {
  standardGeneric("meta")
})

#' @docType methods
#' @rdname resolution
setGeneric("resolution", function(x) {
  standardGeneric("resolution")
})

#' @docType methods
#' @rdname normalized
setGeneric("normalized", function(x) {
  standardGeneric("normalized")
})

# Accessors
#' Print the hic_table
#' @exportMethod hic_table
#' @rdname hic_table
#' @aliases hic_table,character,ANY-method
#' @param x The Hicexp object
#' @return Hicexp class information
#' @examples 
#' data('hicexp2')
#' hic_table(hicexp2)
setMethod("hic_table", "Hicexp", function(x) x@hic_table)

#' Print the results
#' @exportMethod results
#' @rdname results
#' @aliases results,character,ANY-method
#' @param x The Hicexp object
#' @return Hicexp class information
#' @examples 
#' data('hicexp2')
#' results(hicexp2)
setMethod("results", "Hicexp", function(x) x@comparison)

#' Print the metadata
#' @exportMethod meta
#' @rdname meta
#' @aliases meta,character,ANY-method
#' @param x The Hicexp object
#' @return Hicexp class information
#' @examples 
#' data('hicexp2')
#' meta(hicexp2)
setMethod("meta", "Hicexp", function(x) x@metadata)

#' Print the resolution
#' @exportMethod resolution
#' @rdname resolution
#' @aliases resolution,character,ANY-method
#' @param x The Hicexp object
#' @return Hicexp class information
#' @examples 
#' data('hicexp2')
#' resolution(hicexp2)
setMethod("resolution", "Hicexp", function(x) x@resolution)

#' Print the indicator for if the data is normalized
#' @exportMethod normalized
#' @rdname normalized
#' @aliases normalized,character,ANY-method
#' @param x The Hicexp object
#' @return Hicexp class information
#' @examples 
#' data('hicexp2')
#' normalized(hicexp2)
setMethod("normalized", "Hicexp", function(x) x@normalized)

---
title: "Visualizing multiHiCcompare results in Juicebox"
author: "John C. Stansfield & Mikhail G. Dozmorov"
package: multiHiCcompare
output:
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{juiceboxVisualization}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Introduction 

`multiHiCcompare` provides a method for detecting significant differentially interacting regions (DIRs) in Hi-C data. These DIRs are represented by pairs of genomic regions changing their interaction strength between conditions. It may be of interest for the user to visualize these DIRs on an interactive chromatin interaction heatmap in order to determine where they occur in relation to each other and numerous genomic annotations. The `Juicebox` software provided by the Aiden Lab [https://www.aidenlab.org/](https://www.aidenlab.org/) can be used to visualize your Hi-C data and `multiHiCcompare` results. 

# Getting started

You will first need to download `Juicebox` from here: [https://github.com/aidenlab/Juicebox/wiki/Download](https://github.com/aidenlab/Juicebox/wiki/Download)

Once you have downloaded and installed `Juicebox` you may want to go through the provided tutorial here: [https://github.com/aidenlab/Juicebox/wiki/Visualization](https://github.com/aidenlab/Juicebox/wiki/Visualization)

If the Hi-C data you are analyzing was originally generated by the Aiden Lab, the data should be available in `Juicebox` by default. You will not need to perform any extra steps to open the heatmap, simply find your dataset under the `File > Open` menu in `Juicebox`. If your data did not originally generate by the Aiden Lab, you will need to obtain it in the form of a `.hic` file. `.hic` files can be read into `Juicebox` using the `File > Open > Local...` menu. If your data is not in the form of a `.hic` file you will need to convert it to a `.hic` file. This can be done using the `Juicer tools` command `pre`. Instructions for this process can be found here: [https://github.com/aidenlab/juicer/wiki/Pre](https://github.com/aidenlab/juicer/wiki/Pre).

# Example 

For our example, we will use the data from Rao 2017. We compared the data between the normal HCT-116 cells and the cells treated with auxin for 6 hours. The Rao 2017 data are available in `Juicebox` by default under `File > Open` menu, "Rao et al. | Cell 2017". You will want to select the main map for "Auxin treated (6 hrs)". <!--You can also add a control map by choosing the "Rao et al. | Cell 2017" "Untreated" map. -->

Assuming you have already analyzed the data using `multiHiCcompare` and you now have a `Hicexp` object containing the comparison results you can use the `exportJuicebox` function to export the list of DIRs as an annotations file for input into `Juicebox`. Say your `Hicexp` object is named `rao2017` simply run the following line of code in R.

```{r, eval=FALSE}
exportJuicebox(rao2017, logfc_cutoff = 2, logcpm_cutoff = 1, p.adj_cutoff = 0.001, file_name = "rao2017Annotations.txt")
```

This function will create a text file in your working directory containing the annotations which can then be imported into `Juicebox`. This file has been pre-generated, right-click and save it from [here](https://raw.githubusercontent.com/jstansfield0/Rao2017Annotations/master/rao2017Annotations.txt).

Assuming the "Rao et al. | Cell 2017" "Auxin treated (6 hrs)" data is loaded, click the `Show Annotation Panel` button at the lower right corner of `Juicebox` window. Alternatively, use the `View > Show Annotations Panel` menu. Select `2D Annotations > Add Local...` tab/button, and navigate to the "rao2017Annotations.txt" file. After loading it, the "rao2017Annotations.txt" annotations will be shown in the "Select 2D annotation file(s) to open" panel - select it and click the `Open` button to load in into `Juicebox`. Select chromosome 16 in both drop-down menus below the "Chromosomes" selection toolbar and click the refresh button. The DIRs will appear as blue rectangles on the heatmap. 

```{r, echo=FALSE}
githubURL <- "https://raw.githubusercontent.com/jstansfield0/Rao2017Annotations/master/juicebox.png"
download.file(githubURL,'juicebox.png', mode = 'wb')
```


![](juicebox.png)

Here we can see a screenshot of `Juicebox` with the Rao 2017 data loaded and our annotations visualized on the heatmap. The blue boxes on the heatmap represent the significant DIRs. You can zoom in or scroll around in the heatmap to better understand where the DIRs occur in relation to each other and on the chromatin map. Use other annotations for more in-depth exploration of the results.

---
title: "multiHiCcompare Vignette"
author: "John C. Stansfield & Mikhail G. Dozmorov"
package: multiHiCcompare
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{multiHiCcompare}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r, echo=FALSE, message=FALSE}
library(multiHiCcompare)
```


# Introduction

`multiHiCcompare` is an extension of the original `HiCcompare` package. It provides functions for the joint normalization and detection of differential chromatin interactions between multiple Hi-C datasets. `multiHiCcompare` operates on processed Hi-C data in the form of chromosome-specific chromatin interaction matrices. It accepts four-column tab-separated text files storing chromatin interaction matrices in a sparse matrix format (see [Creating the hicexp object](#hicexp)). Functions to convert popular Hi-C data formats (`.hic`, `.cool`) to sparse format are available (see `?cooleHCT116_r2sparse`, and the examples below). `multiHiCcompare` differs from other packages that attempt to compare Hi-C data in that it works on processed data in chromatin interaction matrix format instead of raw sequencing data. In addition, `multiHiCcompare` provides a non-parametric method for the joint normalization and removal of biases between multiple Hi-C datasets for comparative analysis. `multiHiCcompare` also provides a general linear model (GLM) based framework for detecting differences in Hi-C data.

# How to use `multiHiCcompare`

## Install `multiHiCcompare` from Bioconductor

```{r, eval = FALSE}
BiocManager::install("multiHiCcompare")
library(multiHiCcompare)
```

## Getting Hi-C Data

You will need processed Hi-C data in the form of sparse upper triangular matrices or BEDPE files to use `multiHiCcompare`. Data is available from several sources and two examples for downloading and extracting data are listed below. If you have full Hi-C contact matrices, you can convert them to sparse upper triangular format using the full `full2sparse` function as shown in [additional functions](#addfunc)

### Extracting data from `.hic` files

Hi-C data is available from several sources and in many formats. `multiHiCcompare` is built to work with the sparse upper triangular matrix format popularized by the lab of Erez Lieberman-Aiden [http://aidenlab.org/data.html](http://aidenlab.org/data.html).  If you already have Hi-C data either in the form of a sparse upper triangular matrix or a full contact matrix you can skip to the creating the `hicexp` object section. If you obtain data from the Aiden Lab in the `.hic` format you will need to first extract the matrices that you wish to compare. 

  1. Download the `straw` software from [https://github.com/theaidenlab/straw/wiki](https://github.com/theaidenlab/straw/wiki) and install it.
  2. Use `straw` to extract a Hi-C sparse upper triangular matrix. An example is below:
  
Say we downloaded and uncompressed the `GSE63525_K562_combined_30.hic ` file from GEO [https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE63525](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE63525), direct link [ftp](ftp://ftp.ncbi.nlm.nih.gov/geo/series/GSE63nnn/GSE63525/suppl/GSE63525_K562_combined_30.hic.gz), [http](https://www.ncbi.nlm.nih.gov/geo/download/?acc=GSE63525&format=file&file=GSE63525%5FK562%5Fcombined%5F30%2Ehic%2Egz)

To extract the raw matrix corresponding to chromosome 22 at the 500kb resolution we would use the following command within the terminal

  `./straw NONE GSE63525_K562_combined_30.hic  22 22 BP 500000 > K562.chHCT116_r22.500kb.txt`

This will extract the matrix from the `.hic` file and save it to the `K562.chHCT116_r22.500kb.txt` text file, in the sparse upper triangular matrix format. See more examples on how to use `straw` at [https://github.com/theaidenlab/straw/wiki/CPP#running](https://github.com/theaidenlab/straw/wiki/CPP#running). Straw requires several inputs for the extraction of data from a `.hic` file.

`<NONE/VC/VC_SQRT/KR> <hicFile(s)> <chr1>[:x1:x2] <chr2>[:y1:y2] <BP/FRAG> <binsize>`

The first argument is the normalization method. For use in `multiHiCcompare` you want the raw data so you should select `NONE`. The second argument is the `.hic` file name. Next is the chromosome numbers of the matrix you want. For an intrachromosomal contact map, both should be the same as in the above example. If you want a matrix of interchromosomal interactions, you can use different chromosomes, i.e. interactions between chromosome 1 and chromosome 2 (Note that `HiCcompare` is only meant to be used on intrachromosomal interactions at this point in development). The next argument is whether you want basepair or fragment files. For `multiHiCcompare` use `BP`. The final argument is the bin size of the matrix (the resolution). To extract a matrix at a resolution of 1MB enter `10000000`. Typical bin sizes are 1MB, 500KB, 100KB, 50KB, 5KB, 1KB. Note that most matrices with resolutions higher than 100KB (i.e., matrices with resolutions of 1KB - 50KB) are typically too sparse (due to insufficient sequencing coverage) for analysis in `multiHiCcompare`. 

From here we can import the matrix into R as you would normally for any tab-delimited file.

  3. Import the data into R `K562.chr22 <- read.table('K562.chr22.500kb.txt', header=FALSE)`
  4. Repeat these steps for any other Hi-C dataset that you wish to compare to the first dataset using  `multiHiCcompare`.
 
### Extracting data from `.cool` files

The `cooler` software, [http://cooler.readthedocs.io/en/latest/index.html](http://cooler.readthedocs.io/en/latest/index.html), allows access to a large collection of Hi-C data. The cooler index [ftp://cooler.csail.mit.edu/coolers](ftp://cooler.csail.mit.edu/coolers) contains Hi-C data for `hg19` and `mm9` from many different sources. To use data in the `.cool` format in `HiCcompare` follow these steps:

  1. Download and install `cooler` from [http://cooler.readthedocs.io/en/latest/index.html](http://cooler.readthedocs.io/en/latest/index.html)
  2. Download a `.cool` file from the cooler index [ftp://cooler.csail.mit.edu/coolers](ftp://cooler.csail.mit.edu/coolers).
  3. Say we downloaded the `Dixon2012-H1hESC-HindIII-allreps-filtered.1000kb.cool` file. See `cooler dump --help` for data extraction options. To extract the contact matrix we use the following commands in the terminal:  
  `cooler dump --join Dixon2012-H1hESC-HindIII-allreps-filtered.1000kb.cool > dixon.hESC.1000kb.txt`
  4. Read in the text file as you would any tab-delimited file in R  
  `hesc1000kb <- read.table("dixon.hESC.1000kb.txt", header = FALSE)`
  5. Convert to a sparse upper triangular matrix using the `HiCcompare::cooler2sparse` function.  
  `sparse <- cooler2sparse(hesc1000kb) `
  6. Repeat the steps for another Hi-C dataset that you wish to compare to the first dataset.


### Using data from HiC-Pro

HiC-Pro is another tool for processing raw Hi-C data into usable matrix files. HiC-Pro will produce a `.matrix` file and a `.bed` file for the data. These `.matrix` files are in a sparse upper triangular format similar to the results of Juicer and the dumped contents of a `.hic` file, however instead of using the genomic start coordinates for the first two columns of the sparse matrix they use an ID number. The `.bed` file contains the mappings for each of these IDs to their genomic coordinates. The original `HiCcompare` package includes a function to convert the results of HiC-Pro into a usable format for analysis in `multiHiCcompare`. When using data from HiC-Pro, it is important to use the raw `.matrix` files and NOT the iced `.matrix` files. The iced `.matrix` files have already had ICE normalization applied to them and are not suitable for entry into `multiHiCcompare`. Here we convert HiC-Pro data for input into `multiHiCcompare`:

```{r, eval=FALSE}
# read in files
mat <- read.table("hic_1000000.matrix")
bed <- read.table("hic_1000000_abs.bed")
# convert to BEDPE
dat <- HiCcompare::hicpro2bedpe(mat, bed)
# NOTE: hicpro2bedpe returns a list of lists. 
#   The first list, dat$cis, contains the intrachromosomal contact matrices
# NOTE: dat$trans contains the interchromosomal 
#   contact matrix which is not used in multiHiCcompare.
```


See the help using `?HiCcompare::hicpro2bedpe` for more details.


## Parallel Processing

Hi-C data is large, especially at high resolutions, and loess normalization is computationally intensive. `multiHiCcompare` was built with parallelization in mind and the best performance when working with large Hi-C experiments (many samples or high resolution) will be achieved when using a computing cluster. Parallel processing can be used for all normalization and comparison functions by setting `parallel = TRUE` in the function options. `multiHiCcompare` uses the Bioconductor `BiocParallel` package for parallel processing. You can set the number of processors to use on Linux with the following command:

```{r, eval = FALSE}
library(BiocParallel)
numCores <- 20
register(MulticoreParam(workers = numCores), default = TRUE)
```

Or on Windows with:

```{r, eval = FALSE}
library(BiocParallel)
numCores <- 20
register(SnowParam(workers = numCores), default = TRUE)
```

where `numCores` is the user-set number of processing cores to be used. For parallel processing in `multiHiCcompare`, jobs are split by chromosome and sometimes distance thus the more processors used, the quicker the function will run. For maximum speed, it is recommended to set `numCores` to the maximum number of processors available. 

## Creating the `hicexp` object {#hicexp}

### Sparse upper triangular format

A sparse matrix format represents a relatively compact and human-readable way to store pair-wise interactions. It is a tab-delimited text format containing three columns: "region1" - a start coordinate (in bp) of the first region, "region2" a start coordinate of the second region, and "IF" - the interaction frequency between them (IFs). Zero IFs are dropped (hence, the _sparse_ format). Since the full matrix of chromatin interactions is symmetric, only the upper triangular portion, including the diagonal, is stored. Typically matrices in this format are stored in separate text files for each chromosome. For use in `multiHiCcompare`, you will need to add a column for the chromosome number. The chromosome number should be entered as just the number. Chromosomes such as X, Y, etc. should be entered as 23, 24, etc. If you are planning to analyze data for more than a single chromosome, you will need to concatenate these matrices together. A sparse Hi-C matrix ready to be input into `multiHiCcompare` should look like the following:

```{r}
data("HCT116_r1") # load example sparse matrix
head(HCT116_r1)
colnames(HCT116_r1) <- c('chr', 'region1', 'region2', 'IF') # rename columns
head(HCT116_r1) # matrix ready to be input into multiHiCcompare
```


If you have full Hi-C contact matrices you can convert them to sparse upper triangular matrices using the `HiCcompare::full2sparse` function and then add a column indicating the chromosome.


Say we have data from 2 experimental conditions with 2 samples each. We can make a `hicexp` object by doing the following.

```{r}
data("HCT116_r1", "HCT116_r2", "HCT116_r3", "HCT116_r4")
hicexp1 <- make_hicexp(HCT116_r1, HCT116_r2, HCT116_r3, HCT116_r4, 
                       groups = c(0, 0, 1, 1), 
                       zero.p = 0.8, A.min = 5, filter = TRUE,
                       remove.regions = hg19_cyto)
hicexp1
```

The `groups` option specifies the experimental groups. You must enter a vector the length of the number of Hi-C matrices with indicators for which group each matrix belongs to. An optional covariate `data.frame` with rows corresponding the Hi-C matrices and columns for each additional covariate can be provided with the `covariates` option. 

Filtering can be performed when creating a `hicexp` object using the `zero.p` and `A.min` options in the `make_hicexp` function. The `zero.p` option allows for filtering by the proportion of zero IFs for an interaction. The `A.min` allows for filtering by a minimum average IF value. These options can be used together or individually to filter your data. Filtering is important to remove interactions with lots of 0 IFs and low average expression. These interactions tend to not be very interesting and can easily become a false positive during difference detection. Additionally, removing these interactions will increase the computational speed of `multiHiCcompare`. If for some reason you do not want to filter the data simply set `filter = FALSE`.

Additionally, you can filter out specific genomic regions such as centromeres or blacklisted regions. `multiHiCcompare` comes with built-in regions to be filtered for hg19 and hg38 which can be accessed like so.

```{r}
data("hg19_cyto")
data("hg38_cyto")

hg19_cyto
```

By default, the `make_hicexp` object will have the `remove.regions` option set to use the `hg19_cyto` object. If your data was not aligned to hg19 or you want other regions to be removed, you can create a `GenomicRanges` object containing the ranges to be removed and the `remove.regions` option to this object. 



### The `hicexp` object

The `hicexp` S4 class has several slots which can be accessed with the accessor functions `hic_table()`, `results()`, and `meta()`. The `hic_table` slot contains the Hi-C matrix in sparse format. The first four columns are the chromosome, region1 start location, region2 start location, and unit distance. All following chromosomes represent the IFs for that interacting pair from each sample. The `comparison` slot is empty at creation but will be filled following use of one of the comparison functions. It contains the same first four columns as the `hic_table` slot, but also has the logFC - log fold change between conditions, logCPM - log counts per million, p.value, and p.adj - multiple testing corrected p-value columns which indicate the significance of the difference for each interacting pair of regions between the conditions. Access the `comparison` slot using `results()`. The `metadata` slot contains the `data.frame` of covariates for the experiment. Access the `metadata` slot by using `meta()`. The other slots are mainly for internal use, and the typical user does not need to be concerned with them. 



## Normalization

`multiHiCcompare` comes with a few methods for normalizing your Hi-C data. Our joint normalization methods are again based on the MD plot as in the original `HiCcompare`. The MD plot is similar to the MA plot or the Bland-Altman plot. $M$ is the $log2$ difference between the interaction frequencies from the two datasets. $D$ is the unit distance between the two interacting regions. Loess is performed on the data after it is represented in the MD coordinate system. 

### Library scaling

The simplest form of normalization to compare Hi-C data is library scaling. `multiHiCcompare` provides the `hic_scale()` function to scale the Hi-C libraries from each sample to the size of the smallest library. If you believe that any trends present in your data are important differences and not due to bias, then you can use library scaling for normalizing your data as follows. 

```{r, eval=FALSE}
data("hicexp2")
hicexp2 <- hic_scale(hicexp2)
```

Note that you need to use either simple scaling or loess normalization method. It is recommended to use either cyclic loess or fast loess that will implicitly rescale the libraries and remove unwanted trends.

### Cyclic Loess Normalization

`multiHiCcompare` provides a cyclic loess method for the joint normalization of multiple Hi-C datasets. The method is based on representing the data on an MD plot. The MD plot is similar to the MA plot (Bland-Altman plot) which is commonly used for the visualization of gene expression differences. $M$ is defined as the log difference between the two data sets $M = log_2(IF_2/IF_1)$, where $IF_1$ and $IF_2$ are interaction frequencies of the first and the second Hi-C datasets, respectively. $D$ is defined as the distance between two interacting regions, expressed in unit-length of the $X$ resolution of the Hi-C data. A loess regression curve is fit through the MD plot and used to remove global biases by centering the $M$ differences around $M=0$ baseline.

The cyclic loess algorithm proceeds through the following steps. 

1. Choose two out of the $N$ total samples then generate an MD plot. 
2. Fit a loess curve $f(d)$ to the MD plot. 
3. Subtract $f(d)/2$ from the first dataset and add $f(d)/2$ to the second. 
4. Repeat until all unique pairs have been compared. 
5. Repeat until convergence. 

To perform cyclic loess on your Hi-C data you will need to use the `cyclic_loess()` function as shown below:

```{r}
hicexp1 <- cyclic_loess(hicexp1, verbose = FALSE, 
                        parallel = FALSE, span = 0.2)
# make MD plot
MD_hicexp(hicexp1)
```

As can be seen in the above MD plots, the data for each sample has been jointly normalized with all other samples. Note that the user can set the span option. A user-set span will run quicker than the default option of automatically calculating the span. It is best to use the automatic span calculation if you have not worked with the data before, but if you are familiar with it then setting the span is a way to speed up processing. The `hic_table` slot in the `hicexp` object has also been updated with the normalized IFs.

```{r}
hic_table(hicexp1)
```

The runtime of cyclic loess can be decreased when multiple processors are available by setting the `parallel` option to `TRUE`. This option splits up the data by chromosome and sends each chromosome's data to a parallel processor. 

### Fast Loess Normalization (Fastlo)

In addition to the standard cyclic loess method, `multiHiCcompare` also implements the Fast Loess (Fastlo) joint normalization algorithm. Our implementation of fastlo is adapted to Hi-C data on a per-distance basis. To perform "fastlo" on Hi-C data we first split the data into $p$ pooled matrices. The "progressive pooling" is used to split up the Hi-C matrix by unit distance such that distance 0 is its own pool, distances 1 and 2 are pooled, distance 3, 4, 5 are pooled, and so on until all unit distances belong to one of $p$ pools. Each matrix will have an $IF_{gj}$ value with $g$ interacting pairs for each of the $j$ samples. These $p$ matrices can then be input into the "fastlo" algorithm using the following steps. 

1. Create the vector $\hat{IF}_{pgj}$, the row means of the $p^{th}$ matrix. This is the equivalent of creating an average IF at distance pool $p$. 
2. Plot $\hat{IF}_{p}$ versus $(IF_{pg} - \hat{IF_p})$ for each sample $j$. This is equivalent to an MA plot at a genomic distance pool $p$. 
3. Fit a loess curve $f(x)$ to the plot. 
4. Subtract $f(x)$ from sample $j$. 
5. Repeat for all remaining replicates. 
6. Repeat until algorithm converges. 

You can perform fastlo normalization on your data as follows:


```{r}
data("hicexp2")
# perform fastlo normalization
hicexp2 <- fastlo(hicexp2, verbose = FALSE, parallel = FALSE)
# make MD plot
MD_hicexp(hicexp2)
```


Again, the above MD plots show the normalized data. `fastlo()` can also make use of parallelization to speed up computation speeds by setting the `parallel` option to `TRUE`. The results of `fastlo()` and `cyclic_loess()` may be slightly different, but both should result in the removal of biases between Hi-C datasets. `fastlo()` will have quicker run times compared to `cyclic_loess()`, but `cyclic_loess()` will likely give a slightly better normalization.  


## Difference Detection

`multiHiCcompare` provides two main ways to perform a differential comparison between the groups or conditions of your Hi-C experiment. For simple experiments where only a comparison between two groups is being made, the `hic_exactTest()` function can be used. For more complex experiments with covariates or multiple groups, the `hic_glm()` function should be used. Both of these functions make use of the `edgeR` package for fitting negative binomial models to the Hi-C data. For the difference detection steps, `multiHiCcompare` first splits the data up by distance using the progressive pooling described in the fastlo section. Each distance pool is then treated similarly to an independent RNA-seq data matrix on which `edgeR`'s functions are applied to fit the specified model. This process is illustrated in Figure 1 below.

![](multiHiCcompare_glm.png)

**Figure 1.** The off-diagonal analysis of multiple Hi-C replicates. Dashed lines represent the off-diagonal vectors of interaction frequencies at a given distance between interacting regions. Right: Converted into a matrix format similar to RNA-seq data, IFs can be loess normalized, variance across replicates can be estimated using an empirical Bayes approach, and differences can be detected using log-linear GLMs. 


### Exact Test

For simple Hi-C experiments the `hic_exactTest()` function can be used as shown below:

```{r}
hicexp1 <- hic_exactTest(hicexp1, p.method = 'fdr', 
                         parallel = FALSE)

# plot results
MD_composite(hicexp1)
```

The above composite MD plot displays where any significant differences are detected between the two groups. This function can also be sped up by using the `parallel` option. The results of the comparison are then saved in the `comparison` slot of the `hicexp` object.

```{r}
results(hicexp1)
```

In this `data.table` the first 3 columns represent the identity of the interaction, then followed by the unit genomic distance (`D`), the log fold change difference between the groups (`logFC`), the log counts per million for the interaction (`logCPM`), the p-value and finally the multiple testing correction p-value (`p.adj`). The type of multiple testing applied can be changed using the `p.method` option. To view what other adjustment methods are available look at the help for `?p.adjust`. 

### GLM Methods

For more complex Hi-C experiments the `hic_glm()` function must be used. To use this function, a design matrix must first be created. Here use the `hicexp2` object with some covariates and create the design matrix.

```{r}
batch <- c(1,2,1,2)
# produce design matrix
d <- model.matrix(~factor(meta(hicexp2)$group) + factor(batch))
```

The design matrix should contain the covariates of interest. Any categorical variables should be entered as factors. Next, the comparison of interest will need to be specified using either the `contrast` or the `coef` option. For this example we are interested in the group difference thus we can set `coef = 2` to test if the group effect is equal to 0. For more information on using `contrast` and `coef` please see the `edgeR` user manual. Now we are ready to perform the comparison.

```{r, eval=FALSE}
hicexp2 <- hic_glm(hicexp2, design = d, coef = 2, method = "QLFTest", p.method = "fdr", parallel = FALSE)
```


There are three methods by which `hic_glm()` can be performed. The default method is to the use the `QLFTest` which makes use of the quasi-likelihood model. Additionally, there is the `LRTest` which conducts a likelihood ratio test. The final method is the `Treat` method which conducts a test relative to a specified fold change threshold. For this option, the `M` option will need to be used to specify the log2 fold change threshold.

```{r, eval=FALSE}
# use Treat option
hicexp2 <- hic_glm(hicexp2, design = d, coef = 2, method = "Treat", 
                  M = 0.5, p.method = "fdr", parallel = FALSE)
```

## Downstream analysis

For downstream analysis of the results of `multiHiCcompare`, you may want to filter the results. This can be accomplished by using the `topDirs` function. Setting the `return_df = 'pairedbed'` will return a table of the interacting pairs filtered by your specifications.

```{r}
td <- topDirs(hicexp1, logfc_cutoff = 0.5, logcpm_cutoff = 0.5,
        p.adj_cutoff = 0.2, return_df = 'pairedbed')
head(td)
```

Additionally, you can summarize the regions that were detected as significant at least once by setting `return_df = 'bed'`.

```{r}
counts <- topDirs(hicexp1, logfc_cutoff = 0.5, logcpm_cutoff = 0.5, 
                  p.adj_cutoff = 0.2, return_df = 'bed', pval_aggregate = "max")
head(counts)
```

The resulting table when `return_df = 'bed'` is used can be input into the following plot function to visualize the p-values of the top differentially interacting regions (DIRs).

```{r}
plot_pvals(counts)
```

Or to visualize the counts of the top DIRs.

```{r}
plot_counts(counts)
```



## Other functions

There are several other functions included in `multiHiCcompare`. `manhattan_hicexp()` produces a Manhattan plot for the results of a comparison to identify "hotspot" regions of the genome where large numbers of significant differences are found.

```{r}
manhattan_hicexp(hicexp1, p.adj_cutoff = "standard")
```

There is also the MD plotting function `MD_hicexp()` which will plot MD plots for each unique pair of samples in the `hicexp` object.

```{r}
MD_hicexp(hicexp1, prow = 2, pcol = 3)
```

The `MD_composite()` function will plot a composite MD plot of the results of a comparison where the significant differences are highlighted.

```{r}
MD_composite(hicexp1)
```


# Session Info

```{r, echo=FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/topDirs.R
\name{topDirs}
\alias{topDirs}
\title{Filter results of multiHiCcompare}
\usage{
topDirs(
  hicexp,
  logfc_cutoff = 1,
  logcpm_cutoff = 1,
  p.adj_cutoff = 0.01,
  D_cutoff = 1,
  return_df = "pairedbed",
  pval_aggregate = "max"
)
}
\arguments{
\item{hicexp}{A hicexp object which has been compared.}

\item{logfc_cutoff}{The logFC value you wish to filter
by. Defaults to 1.}

\item{logcpm_cutoff}{The logCPM cutoff you wish to
filter by. Defaults to 1.}

\item{p.adj_cutoff}{The adjusted p-value cutoff you wish to filter
by. Defaults to 0.01.}

\item{D_cutoff}{The distance cutoff you wish to filter
by. Interactions with a D < D_cutoff will be filtered.
Defaults to 1.}

\item{return_df}{The format for the data.frame returned
by the function. Options are "bed" and "pairedbed" (Default).}

\item{pval_aggregate}{Method to aggregate region-specific p-values.
If a region differentially interacts with several other regions,
the p-values are aggregated using a 'max' method (Default, select maximum
p-value, most conservative), or the Fisher ('fisher'), Lancaster ('lancaster'),
or Sidak ('sidak') methods (see 'aggregate' package).
regions, it is assigned a single p-value aggregated from several}
}
\value{
A data.table containing the filtered results.
}
\description{
Filter results of multiHiCcompare
}
\details{
This function is meant to filter the results of
    multiHiCcompare. The top differentially interacting 
    regions (DIRs) can be returned by using this function.
    When the return_df = "bed" option is set the resulting
    data.frame can be input into the plot_pvals or plot_counts
    functions to visualize the top DIRs.
}
\examples{
data('hicexp_diff')
topDirs(hicexp_diff)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/perm_test.R
\name{perm_test}
\alias{perm_test}
\title{Perform a permutation test to check enrichment of a genomic
    feature with DIRs detected by multiHiCcompare}
\usage{
perm_test(
  hicexp,
  feature,
  p.adj_cutoff = 10^-10,
  logfc_cutoff = 1,
  num.perm = 1000,
  pval_aggregate = "max"
)
}
\arguments{
\item{hicexp}{A Hicexp object which has been compared.}

\item{feature}{A GRanges object containing locations for
a genomic feature you would like to test for enrichment
in the differentially interacting regions (DIRs).}

\item{p.adj_cutoff}{The adjusted p-value cutoff for
declaring a region significant. See ?topDirs for
more information. Defaults to 10^-10}

\item{logfc_cutoff}{The log fold change cutoff for
a region to be declared significant. See ?topDirs
for more information. Defaults to 1.}

\item{num.perm}{The number of permutations to run.
Defaults to 1000.}

\item{pval_aggregate}{Method to aggregate region-specific p-values.
If a region differentially interacts with several other regions,
the p-values are aggregated using a 'max' method (Default, select maximum
p-value, most conservative), or the Fisher ('fisher'), Lancaster ('lancaster'),
or Sidak ('sidak') methods (see 'aggregate' package).
regions, it is assigned a single p-value aggregated from several. See ?topDirs}
}
\value{
The permutation p-value
}
\description{
Perform a permutation test to check enrichment of a genomic
    feature with DIRs detected by multiHiCcompare
}
\examples{
\dontrun{
data("hicexp_diff")
data("hg19_cyto")
perm_test(hicexp_diff, hg19_cyto)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classes.R
\docType{class}
\name{Hicexp-class}
\alias{Hicexp-class}
\title{An S4 class for working with Hi-C data}
\value{
Hicexp class
}
\description{
An S4 class for working with Hi-C data
}
\section{Slots}{

\describe{
\item{\code{hic_table}}{A data.table containing the sparse upper triangular matrix 
for your Hi-C data.}

\item{\code{comparison}}{The results of a multiHiCcompare comparison.}

\item{\code{metadata}}{Data.frame for covariate information.}

\item{\code{resolution}}{The resolution of the dataset.}

\item{\code{normalized}}{Indicator for if data has been normalized.}
}}

\examples{
data('hicexp2')
hicexp2
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exportJuicebox.R
\name{exportJuicebox}
\alias{exportJuicebox}
\title{Export multiHiCcompare results for visualization in Juicebox}
\usage{
exportJuicebox(
  hicexp,
  logfc_cutoff = 1,
  logcpm_cutoff = 1,
  p.adj_cutoff = 0.01,
  D_cutoff = 1,
  file_name = "juiceboxAnnotations.txt",
  color = "0,0,255"
)
}
\arguments{
\item{hicexp}{A hicexp object which has been compared.}

\item{logfc_cutoff}{The logFC value you wish to filter
by. Defaults to 1.}

\item{logcpm_cutoff}{The logCPM cutoff you wish to
filter by. Defaults to 1.}

\item{p.adj_cutoff}{The adjusted p-value cutoff you wish to filter
by. Defaults to 0.01.}

\item{D_cutoff}{The distance cutoff you wish to filter
by. Interactions with a D < D_cutoff will be filtered.
Defaults to 1.}

\item{file_name}{The file name of the text file to be saved.}

\item{color}{A decimal RGB color code. Should be a character
value in form of "0,0,255". Defaults to color code for
blue. This will determine the color of the annotations
on the Juicebox heatmap.}
}
\value{
A text file containing annotations for input into Juicebox.
}
\description{
Export multiHiCcompare results for visualization in Juicebox
}
\details{
This function is meant to filter the results of
    multiHiCcompare and export the significant 
    differentially interacting regions into a text file which
    can be imported into Juicebox as a 2D annotations file. This
    will allow you to visualize where your DIRs occur on the heatmap
    of the interactions. Please see the included vignette on using
    Juicebox to visualize multiHiCcompare results. This can be accessed
    with browseVignettes("multiHiCcompare").
}
\examples{
data('hicexp_diff')
exportJuicebox(hicexp_diff, file_name = "juiceboxAnnotations.txt") 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/HCT116_r1.R
\docType{data}
\name{HCT116_r1}
\alias{HCT116_r1}
\title{A 4 column sparse matrix for a Hi-C matrix.}
\format{
An object of class \code{data.frame} with 56603 rows and 4 columns.
}
\source{
Data from Rao 2017. See their website at
    \url{http://www.aidenlab.org/}
     Or the the GEO link to download the data
    \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE104888}
}
\usage{
HCT116_r1
}
\value{
A matrix
}
\description{
A matrix object with 4 columns and 56603 rows. 
    Sample 1 of 7 included as example Hi-C data.
    This is replicate 1 of HCT-116 cell
    line at 100KB resolution from chHCT116_r22.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classes.R
\docType{methods}
\name{hic_table}
\alias{hic_table}
\alias{hic_table,Hicexp-method}
\alias{hic_table,character,ANY-method}
\title{Print the hic_table}
\usage{
hic_table(x)

\S4method{hic_table}{Hicexp}(x)
}
\arguments{
\item{x}{The Hicexp object}
}
\value{
Hicexp class information
}
\description{
Print the hic_table
}
\examples{
data('hicexp2')
hic_table(hicexp2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cyclic_loess.R
\name{cyclic_loess}
\alias{cyclic_loess}
\title{Cyclic Loess normalization for Hi-C data}
\usage{
cyclic_loess(
  hicexp,
  iterations = 3,
  span = NA,
  parallel = FALSE,
  verbose = FALSE
)
}
\arguments{
\item{hicexp}{A hicexp object}

\item{iterations}{The number of iterations (cycles) 
of loess normalization to perform. Defaults to 3.}

\item{span}{The span for loess normalization. Defaults to
NA indicating that span will be automatically calculated
using generalized cross validation.}

\item{parallel}{Logical. Should parallel processing be used?}

\item{verbose}{Logical. Should messages about loess normalization
be printed to the screen.}
}
\value{
A hicexp object that has been normalized.
}
\description{
Cyclic Loess normalization for Hi-C data
}
\details{
This function performs cyclic loess normalization
   on a Hi-C experiment. multiHiCcompare's cyclic loess procedure
   is a modified version of Ballman's (2004) cyclic loess and
   the joint loess normalization used in the original HiCcompare.
   For each unique pair of samples in the hicexp object an MD plot
   is generated. A loess curve is fit to the MD plot and then the 
   fitted values are used to adjust the data. This is performed on
   all unique pairs and then repeated until convergence.
}
\examples{
#' data("hicexp2")
hicexp2 <- cyclic_loess(hicexp2, span = 0.7)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{MD_composite}
\alias{MD_composite}
\title{Plot a composite MD plot with the results of a comparison}
\usage{
MD_composite(hicexp, plot.chr = NA, D.range = 1)
}
\arguments{
\item{hicexp}{A hicexp object which has 
had a multiHiCcompare comparison step performed on it.}

\item{plot.chr}{A specific chromosome or 
set of chromosome which you want to plot.
This should be a numeric value, i.e. to
plot chromosome 1 set plot.chr = 1, to
plot chromosomes 1 and 5 set plot.chr 
= c(1, 5). Defaults to NA indicating that
all chromosomes present in the hicexp
will be plotted.}

\item{D.range}{Allows for subsetting of the plot by
Distance. Set to proportion of total distance 
that you want to be displayed. Value of 1 
indicates that the entire distance range 
will be displayed. Defaults to 1.}
}
\value{
An MD plot
}
\description{
Plot a composite MD plot with the results of a comparison
}
\examples{
data("hicexp_diff")
MD_composite(hicexp_diff)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/smartApply.R
\name{smartApply}
\alias{smartApply}
\title{Function to apply either biocParallel or standard lapply}
\usage{
smartApply(parallel, x, FUN, ...)
}
\arguments{
\item{parallel}{Logical, should parallel processing be used?}

\item{x}{The main list object which the function will be applied to.}

\item{FUN}{The function to be applied.}

\item{...}{Additional arguments for bplapply or lapply.}
}
\value{
results of lapply or bplapply
}
\description{
Function to apply either biocParallel or standard lapply
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filtering.R
\name{hic_filter}
\alias{hic_filter}
\title{Perform filtering on a Hi-C experiment}
\usage{
hic_filter(hicexp, zero.p = 0.8, A.min = 5, remove.regions = hg19_cyto)
}
\arguments{
\item{hicexp}{A hicexp object.}

\item{zero.p}{The proportion of zeros in a row to filter by. 
If the proportion of zeros in a row is <= zero.p
the row will be filtered out, i.e. zero.p = 1 means
nothing is filtered based on zeros and zero.p = 0 
will filter rows that have any zeros.}

\item{A.min}{The minimum average expression value
(row mean) for an interaction pair. If the 
interaction pair has an average expression 
value less than A.min the row will be filtered
out.}

\item{remove.regions}{A GenomicRanges object indicating
specific regions to be filtered out. By default
this is the hg19 centromeric, gvar, and stalk
regions. Also included in the package is
hg38_cyto. If your data is not hg19 you will 
need to substitute this file. To choose not 
to filter any regions set regions = NULL.}
}
\value{
A hicexp object.
}
\description{
Perform filtering on a Hi-C experiment
}
\details{
This function is used to filter out
    the interactions that have low average IFs
    or large numbers of 0 IF values. If you have
    already performed filtering when making your
    hicexp object do not use this again. As these
    interactions are not very interesting and
    are commonly false positives during difference
    detection it is better to remove them from
    the dataset. Additionally, filtering will
    help speed up the run time of multiHiCcompare. 
    Filtering can be performed before or after 
    normalization, however the best computational
    speed gain will occur when filtering is done
    before normalization.
}
\examples{
data("hicexp2")
hicexp2 <- hic_filter(hicexp2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hicexp_diff.R
\docType{data}
\name{hicexp_diff}
\alias{hicexp_diff}
\title{hicexp object with 7 samples from two groups.}
\format{
An object of class \code{Hicexp} of length 1.
}
\source{
Data from Rao 2017. See their website at
    \url{http://www.aidenlab.org/}
     Or the the GEO link to download the data
    \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE104888}
}
\usage{
hicexp_diff
}
\value{
A hicexp object
}
\description{
A hicexp object with a hic_table slot containing 666 rows
    and a metadata slot containing 3 covariates. Same data
    as from "hicexp2" object but has been normalized and
    tested for differences with the hic_exactTest.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/library_scaling.R
\name{hic_scale}
\alias{hic_scale}
\title{Perform library scaling on a hicexp object}
\usage{
hic_scale(hicexp)
}
\arguments{
\item{hicexp}{A hicexp object.}
}
\value{
A hicexp object.
}
\description{
Perform library scaling on a hicexp object
}
\details{
This function will perform library scaling 
    on a hicexp object. Scaling is performed 
    separately for each chromosome. This is an 
    alternative normalization method to the
    cyclic loess and fastlo methods also
    provided in multiHiCcompare. Use this normalization
    method if for some reason you do not want to remove
    trends in the data and only want to normalize based
    on library size.
}
\examples{
data("hicexp2")
hicexp2 <- hic_scale(hicexp2)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classes.R
\name{show,Hicexp-method}
\alias{show,Hicexp-method}
\alias{show,character,ANY-method}
\title{Print information about a HiCexp object}
\usage{
\S4method{show}{Hicexp}(object)
}
\arguments{
\item{object}{A Hicexp object}
}
\value{
HiCexp information
}
\description{
Print information about a HiCexp object
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hg19_cyto.R
\docType{data}
\name{hg19_cyto}
\alias{hg19_cyto}
\title{A GenomicRanges object containing centromeric, gvar, and stalk regions.}
\format{
An object of class \code{GRanges} of length 70.
}
\source{
Data from UCSC
    \url{http://hgdownload.cse.ucsc.edu/goldenPath/hg19/database/cytoBand.txt.gz}
}
\usage{
hg19_cyto
}
\value{
A GRanges object
}
\description{
A GRanges object with 2 metadata columns and 70 rows. 
    These ranges indicate the locations of centromeres,
    stalks, and gvar regions from hg19.
    Use this for filtering out these regions from 
    your data.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/glm.R
\name{hic_exactTest}
\alias{hic_exactTest}
\title{Perform exact test based difference detection on a Hi-C experiment}
\usage{
hic_exactTest(hicexp, parallel = FALSE, p.method = "fdr", max.pool = 0.7)
}
\arguments{
\item{hicexp}{A hicexp object.}

\item{parallel}{Logical, should parallel processing be used?}

\item{p.method}{Charact string to be input into p.adjust()
as the method for multiple testing correction. Defaults to "fdr".}

\item{max.pool}{The proportion of unit distances after
which all further distances will be pooled. Distances
before this value will be progressively pooled and
any distances after this value will be combined
into a single pool. Defaults to 0.7. Warning: do
not adjust this value from the default unless you
are getting errors related to the lfproc function
or due to sparsity in fastlo normalization. If these
errors occur it is due to either sparsity or low 
variance and max.pool will need to be lowered; 
typically to 0.5 or 0.6.}
}
\value{
A hicexp object with the comparison slot filled.
}
\description{
Perform exact test based difference detection on a Hi-C experiment
}
\details{
This function performs the edgeR exact test on a per distance
    basis for Hi-C data. It tests for differences between two groups
    when the groups are the only variable of interest. This is
    an application of the negative binomial exact test proposed
    by Robinson and Smyth (2008) for a difference in mean between
    the groups. These exact tests are applied to the Hi-C data
    on a distance group basis using "progressive pooling" of 
    distances.
}
\examples{
\dontrun{
data("hicexp_diff")
hicexp_diff <- hic_exactTest(hicexp_diff)}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/glm.R
\name{hic_glm}
\alias{hic_glm}
\title{Function to perform GLM differential analysis on Hi-C experiment}
\usage{
hic_glm(
  hicexp,
  design,
  contrast = NA,
  coef = NA,
  method = "QLFTest",
  M = 1,
  p.method = "fdr",
  parallel = FALSE,
  max.pool = 0.7
)
}
\arguments{
\item{hicexp}{A hicexp object,}

\item{design}{A design matrix for the GLM.}

\item{contrast}{Numeric vector or matrix specifying one or more 
contrasts of the linear model coefficients to be tested 
equal to zero.}

\item{coef}{integer or character index vector indicating which 
coefficients of the linear model are to be tested equal to zero.}

\item{method}{The test method to be performed. Should be one of
"QLFTest", "LRTest", or "Treat".}

\item{M}{The log2 fold change value for a TREAT analysis.}

\item{p.method}{p-value adjustment method to be used. Defaults
to "fdr". See ?p.adjust for other adjustment options.}

\item{parallel}{Logical, Should parallel processing be used?}

\item{max.pool}{The proportion of unit distances after
which all further distances will be pooled. Distances
before this value will be progressively pooled and
any distances after this value will be combined
into a single pool. Defaults to 0.7. Warning: do
not adjust this value from the default unless you
are getting errors related to the lfproc function
or due to sparsity in fastlo normalization. If these
errors occur it is due to either sparsity or low 
variance and max.pool will need to be lowered; 
typically to 0.5 or 0.6.}
}
\value{
A hicexp object with a filled in comparison slot.
}
\description{
Function to perform GLM differential analysis on Hi-C experiment
}
\details{
This function performs the specified edgeR GLM based test
    on a per distance basis on the Hi-C data. Distances groups
    are pooled using "progressive pooling". There are 3 options
    for the type of GLM based test to be used which is specified
    with the method option. \cr
    \code{QLFTest} will use edgeR's glmQLFit and glmQLFTest functions which
    makes use of quasi-likelihood methods described in Lund
    et al (2012). \cr
    \code{LRTest} uses edgeR's glmFit and glmLRT functions which uses
    a interaction-wise negative binomial general linear model.
    This method uses a likelihood ratio test for the coefficients
    specified in the model. \cr
    \code{Treat} uses edgeR's glmTreat function which performs a test
    for differential expression with a minimum required fold-change
    threshold imposed. It tests whether the absolute value of the 
    log2 fold change is greater than the value specified as the \code{M}
    option.
}
\examples{
\dontrun{
data("hicexp_diff")
d <- model.matrix(~factor(meta(hicexp_diff)$group) + factor(c(1,2,1,2)))
hicexp_diff <- hic_glm(hicexp_diff, design = d, coef = 2)}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/manhattan.R
\name{plot_counts}
\alias{plot_counts}
\title{Plot the count results from topDirs}
\usage{
plot_counts(dirs, plot.chr = NA)
}
\arguments{
\item{dirs}{The output of the topDirs function when the return_df 
option is set to "bed".}

\item{plot.chr}{A numeric value indicating a specific
chromosome number to subset the plot to. Defaults
to NA indicating that all chromosomes will be plotted.}
}
\value{
A plot.
}
\description{
Plot the count results from topDirs
}
\examples{
data('hicexp_diff')
dirs <- topDirs(hicexp_diff, return_df = 'bed')
plot_counts(dirs)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/manhattan.R
\name{manhattan_hicexp}
\alias{manhattan_hicexp}
\title{Manhattan plot function for results of multiHiCcompare}
\usage{
manhattan_hicexp(
  hicexp,
  pval_aggregate = "standard",
  return_df = FALSE,
  p.adj_cutoff = 0.05,
  plot.chr = NA
)
}
\arguments{
\item{hicexp}{A hicexp object that has had differences
detected}

\item{pval_aggregate}{string denoting the p-value method to
use for plotting. Options are "standard", "fisher",
"lancaster", "sidak", and "count". "standard" plots a manhattan plot
using all individual p-values (very slow, use with caution).  
"fisher", "lancaster", or "sidak" methods use the Fisher's, Lancaster,
or the Sidak method, respectively, for combining p-values
for each region which are then plotted on the -log10(p-value) Y-axis.
"count" summarizes the number of times a region was detected as 
significant (see "p.adj_cutoff" parameter), plotted on Y-axis. The higher
the dots are, the more significant/more frequent a region was 
detected as significantly differentially interacting. See ?topDirs}

\item{return_df}{Logical, should the data.frame used to
generate the plot be returned?}

\item{p.adj_cutoff}{The adjusted p-value cutoff to be used for 
calling an interaction significant. This is
only used if method = 'count'. Defaults to 
0.05.}

\item{plot.chr}{A numeric value indicating a specific
chromosome number to subset the plot to. Defaults
to NA indicating that all chromosomes will be plotted.}
}
\value{
A manhattan plot and optionally the data.frame used
    to generate the manhattan plot.
}
\description{
Manhattan plot function for results of multiHiCcompare
}
\details{
This function is used to create a manhattan
    plot for the significance of all genomic regions 
    in the dataset. These correspond to the rows (or columns)
    of the upper triangle of the full Hi-C matrix. Each genomic
    region of the Hi-C dataset has multiple interactions it
    is involved in and the significance of all of these can 
    be visualized with \code{pval_aggregate = "standard"}. 
    Alternatively the p-values for all these interactions
    can be combined using either Fisher's, or the Lancaster or the
    Sidac method of combining p-values. Additionally
    the "count" option will plot based on the number of times
    each region was found to be involved in a signficantly 
    different interaction. The 
    manhattan plot can be used to identify "hotspot"
    regions of the genome where major differences
    seem to be located based on the results of a multiHiCcompare
    analysis.
}
\examples{
data("hicexp_diff")
manhattan_hicexp(hicexp_diff, pval_aggregate = "fisher")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/make_hicexp.R
\name{make_hicexp}
\alias{make_hicexp}
\title{Make Hi-C experiment object from data}
\usage{
make_hicexp(
  ...,
  data_list = NA,
  groups,
  covariates = NULL,
  remove_zeros = FALSE,
  zero.p = 0.8,
  A.min = 5,
  filter = TRUE,
  remove.regions = hg19_cyto
)
}
\arguments{
\item{...}{Hi-C data. Data must in sparse upper triangular 
format with 4 columns: chr, region1, region2, IF or
in 7 column BEDPE format with columns chr, start1, 
end1, chr, start2, end2, IF.}

\item{data_list}{Alternate way to enter data. If you have
your Hi-C data in the form of a list already with each
entry of the list representing a sample use this option.}

\item{groups}{A vector of the experimental groups 
corresponding to each Hi-C data object entered.
If it is not in factor form when entered it will
be converted to a factor.}

\item{covariates}{Optional data.frame containing 
covariate information for your Hi-C experiment.
Some examples are enzyme used, batch number, etc.
Should have the same number of rows as the number
of Hi-C data objects entered and columns corresponding
to covariates.}

\item{remove_zeros}{Logical, should rows with 1 or more
zero IF values be removed?}

\item{zero.p}{The proportion of zeros in a row to filter by. 
If the proportion of zeros in a row is <= zero.p
the row will be filtered out, i.e. zero.p = 1 means
nothing is filtered based on zeros and zero.p = 0 
will filter rows that have any zeros.}

\item{A.min}{The minimum average expression value
(row mean) for an interaction pair. If the 
interaction pair has an average expression 
value less than A.min the row will be filtered
out.}

\item{filter}{Logical, should filtering be performed?
Defaults to TRUE. If TRUE it will filter out
the interactions that have low average IFs
or large numbers of 0 IF values. As these
interactions are not very interesting and
are commonly false positives during difference
detection it is better to remove them from
the dataset. Additionally, filtering will
help speed up the run time of multiHiCcompare. 
Filtering can be performed before or after 
normalization, however the best computational
speed gain will occur when filtering is done
before normalization. Filtering parameters
are controlled by the zero.p and A.min options.}

\item{remove.regions}{A GenomicRanges object indicating
specific regions to be filtered out. By default
this is the hg19 centromeric, gvar, and stalk
regions. Also included in the package is
hg38_cyto. If your data is not hg19 you will 
need to substitute this file. To choose not 
to filter any regions set regions = NULL. NOTE:
if you set filter = FALSE these regions will NOT
be removed. This occurs in conjuction with the 
filtering step.}
}
\value{
A hicexp object.
}
\description{
Make Hi-C experiment object from data
}
\details{
Use this function to create a hicexp object for
    analysis in multiHiCcompare. Filtering can also be 
    performed in this step if the filter option is 
    set to TRUE. Filtering parameters are controlled
    by the zero.p and A.min options.
}
\examples{
# load data in sparse upper triangular format
data("HCT116_r1", "HCT116_r2", "HCT116_r3", "HCT116_r4", 
    "HCT116_r5", "HCT116_r6")
# make groups & covariate input
groups <- factor(c(1, 1, 1, 2, 2, 2))
covariates <- data.frame(enzyme = factor(c('mobi', 'mboi', 'mboi',
 'dpnii', 'dpnii', 'dpnii')), batch = c(1, 2, 1, 2, 1, 2))
# make the hicexp object
hicexp <- make_hicexp(HCT116_r1, HCT116_r2, HCT116_r3, HCT116_r4,
     HCT116_r5, HCT116_r6, groups = groups, 
     covariates = covariates)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{MD_hicexp}
\alias{MD_hicexp}
\title{Make MD plots for all combinations of a condition}
\usage{
MD_hicexp(hicexp, prow = 3, pcol = 3, plot.chr = NA, plot.loess = FALSE)
}
\arguments{
\item{hicexp}{A hicexp object.}

\item{prow}{The number of rows to use for the 
grid of MD plots. Defaults to 3.}

\item{pcol}{The number of columns to use for
the grid of MD plots. Defaults to 3.}

\item{plot.chr}{A specific chromosome or 
set of chromosome which you want to plot.
This should be a numeric value, i.e. to
plot chromosome 1 set plot.chr = 1, to
plot chromosomes 1 and 5 set plot.chr 
= c(1, 5). Defaults to NA indicating that
all chromosomes present in the hicexp
will be plotted.}

\item{plot.loess}{Logical, should a loess curve
be plotted over the MD plots. Note setting
this to TRUE will increase the computational
time for plotting.}
}
\value{
A set of MD plots.
}
\description{
Make MD plots for all combinations of a condition
}
\examples{
data("hicexp2")
MD_hicexp(hicexp2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/hicexp2.R
\docType{data}
\name{hicexp2}
\alias{hicexp2}
\title{hicexp object with 4 samples from two groups.}
\format{
An object of class \code{Hicexp} of length 1.
}
\source{
Data from Rao 2017. See their website at
    \url{http://www.aidenlab.org/}
     Or the the GEO link to download the data
    \url{https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE104888}
}
\usage{
hicexp2
}
\value{
A hicexp object
}
\description{
A hicexp object with a hic_table slot containing 666 rows
    from chromosome 22 at 1MB resolution.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{pval_heatmap}
\alias{pval_heatmap}
\title{Function to visualize p-values from multiHiCcompare results}
\usage{
pval_heatmap(hicexp, alpha = NA, chr = 0)
}
\arguments{
\item{hicexp}{A hicexp object that has been
normalized and has had differences detected.}

\item{alpha}{The alpha level at which you will 
call a p-value significant. If this is set to
a numeric value then any p-values >= alpha will
be set to 1 for the visualization in the heatmap.
Defaults to NA for visualization of all p-values.}

\item{chr}{The numeric value for the chromosome that 
you want to plot. Set to 0 to plot all chromosomes
in the dataset.}
}
\value{
A heatmap
}
\description{
Function to visualize p-values from multiHiCcompare results
}
\details{
The goal of this function is to visualize
    where in the Hi-C matrix the differences are
    occuring between two experimental conditions.
    The function will produce a heatmap of the
    -log10(p-values) * sign(logFC) 
    to visualize where the
    significant differences between the datasets
    are occuring on the genome.
}
\examples{
data("hicexp_diff")
pval_heatmap(hicexp_diff, chr = 22)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fastlo.R
\name{fastlo}
\alias{fastlo}
\title{Perform fast loess normalization on a Hi-C experiment}
\usage{
fastlo(
  hicexp,
  iterations = 3,
  span = 0.7,
  parallel = FALSE,
  verbose = FALSE,
  max.pool = 0.7
)
}
\arguments{
\item{hicexp}{A hicexp object}

\item{iterations}{The number of iterations (cycles) 
for fastlo to proceed through.}

\item{span}{The span of loess fitting. Defaults to 0.7. To
automatically calculate a span using the GCV set 
span = NA. However note that setting span = NA will
significantly slow down the normalization process.}

\item{parallel}{Logical. Should parallel processing be
used?}

\item{verbose}{Logical, should messages about
the normalization be printed?}

\item{max.pool}{The proportion of unit distances after
which all further distances will be pooled. Distances
before this value will be progressively pooled and
any distances after this value will be combined
into a single pool. Defaults to 0.7. Warning: do
not adjust this value from the default unless you
are getting errors related to the lfproc function
or due to sparsity in fastlo normalization. If these
errors occur it is due to either sparsity or low 
variance and max.pool will need to be lowered; 
typically to 0.5 or 0.6.}
}
\value{
A hicexp object that is normalized.
}
\description{
Perform fast loess normalization on a Hi-C experiment
}
\details{
This function performs the fast loess (fastlo)
   normalization procedure on a hicexp object. the fast linear 
   loess ("fastlo") method 
   of Ballman (2004) that is adapted to Hi-C data on a per-distance basis.
    To perform 
   "fastlo" on Hi-C data we first split the data into p pooled matrices. 
   The "progressive pooling" is used to split up the Hi-C matrix by unit 
   distance. Fastlo
   is then performed on the MA plots for each distance pool. 
   See Stansfield et al (2018)
   for full description.
}
\examples{
data("hicexp2")
hicexp2 <- fastlo(hicexp2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/classes.R
\docType{methods}
\name{resolution}
\alias{resolution}
\alias{resolution,Hicexp-method}
\alias{resolution,character,ANY-method}
\title{Print the resolution}
\usage{
resolution(x)

\S4method{resolution}{Hicexp}(x)
}
\arguments{
\item{x}{The Hicexp object}
}
\value{
Hicexp class information
}
\description{
Print the resolution
}
\examples{
data('hicexp2')
resolution(hicexp2)
}
